unit Database;

interface

uses           
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, Wwdatsrc, DBTables, Wwtable, FileCtrl, Menus, ShellAPI, WSocket;

type
  TDatawell = class(TDataModule)
    TableEvents: TwwTable;
    TableOptions: TwwTable;
    TableActions: TwwTable;
    TableGlobals: TwwTable;
    TableMacros: TwwTable;
    TableAliases: TwwTable;
    TableChars: TwwTable;
    TableTellhist: TwwTable;
    TableTell: TwwTable;
    TableGroups: TwwTable;
    TableEventSort: TwwTable;
    TableNicknames: TwwTable;
    TableFiltered: TwwTable;
    TableChat: TwwTable;
    TableChathist: TwwTable;
    TableChatlines: TwwTable;
    TableTells: TwwTable;
    TableRetain: TwwTable;
    TableSEvents: TwwTable;
    TableTicker: TwwTable;
    TableReverse: TwwTable;
    TableMenu: TwwTable;
    TableOptions2: TwwTable;
    TableVariables: TwwTable;
    TableTools: TwwTable;
    TableRooms: TwwTable;
    TableExits: TwwTable;                                                                
    TableMaps: TwwTable;
    TableOptions3: TwwTable;
    TableRMemos: TwwTable;
    TableOptions4: TwwTable;
    TableMenuTemp: TwwTable;
    TableProfiles: TwwTable;
    TableMudlist: TwwTable;
    TableMudlistDesc: TwwTable;
    TableGlobals2: TwwTable;
    TableSessions: TwwTable;
    procedure DatawellCreate(Sender: TObject);
    procedure DatawellDestroy(Sender: TObject);
  private
    function IsCharting: string;
    function IsFollowing: string;
    function IsPanicking: string;
    { Private declarations }
  public
    { Public declarations }
    exedir, IPFailed, gline1, gline2, homesite, codesite, regmud, versionbase, bde: string;
    mud, specialcode, specialcode2, specialcode3, cr, cr2, masterindex: string;
    version, version2, version3, player, password, password2, bufferpassword, code, delim: string;
    lastalias, lastmacro, lastevent, lastgroup, lastmud, repeatstring: string;
    lastplayer, ptitle: string;
    masterinteger, randomcode, randommax, chatlimit, optionpage, idle: integer;
    eventpage, lastfunction, playindex: integer;
    charting, following, workingoffline, ringed, superringed, datachecking, abortdata, connected: boolean;
    DataFailed, tablessetup, wizard, AllCreated, GotData, Mess, disconnected: boolean;
    connected2, chatspaused, tellspaused, betaversion: boolean;
    selx, script, rvars, svars, pchats, ptells, playlist: TStringList;
    handpoint: TCursor;
    procedure SetupTables(master: string);
    procedure SetupTables2(table: TwwTable; master: string);
    function FigureColor(col: integer): integer;
    function ColorFigure(col: integer): integer;
    function FigureSound(str: string): string;
    function ValidAlias(str: string): boolean;
    function ValidWord(str: string): boolean;
    function ValidWordNumber(str: string): boolean;
    function ValidLowerWordNumber(str: string): boolean;
    function ANOnly(str: string): string;
    function ToInt(str: string): integer;
    function ToIntPure(str: string): integer;
    function Subs(oldstr, newstr, str: string): string;
    function Subs2(oldstr, newstr, str: string): string;
    function Nick(str: string): string;
    procedure ClearFiltered;
    procedure DeleteFiltered;
    function FigureDate: string;
    function FigureButton(letter: string): string;
    function FigureLetter(button: string): string;
    procedure Help(helpfile: string);
    function CutLeadingSpaces(data: string): string;
    function CutTrailingSpaces(data: string): string;
    function CutAllSpaces(data: string): string;
    function CutAllOfOneChar(cut, data: string): string;
    function CheckAllSpaces(data: string): string;
    function FigureSoundFile(data: string): string;
    function Cap(data: string): string;
    function Reverse(data: string): string;
    function ReplaceVariables(str: string): string;
    function ReplaceFunctions(str: string): string;
    function CorrectPunctuation(str: string): string;
    procedure UpdateVariable(variable, value: string);
    procedure Explode(str, element: string; var SL: TStringList);
    function IsMacro(str: string): boolean;
    function IsAlias(str: string): boolean;
    function FigureQuickchar(str: string): string;
    function FigureLogic(str: string): boolean;
    function IsLogical(str: string): string;
    function DoLogic(str: string): boolean;
    function EXE(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;
    function RandomLetter: string;
    function CheckIP(ip: string): boolean;
    function FigureID: string;
    function FigureID2: string;
    function GetDir(which: integer): string;
    function SetDir(which: integer; dir: string): string;
    function NewExitOrder(map: string; x, y: integer): integer;
    function IsMap(map: string): boolean;
    function SearchWell(str: string): string;
    procedure AddChat(cmd, line, who, mess: string);
    procedure AddTell(me, from, mess: string);
    procedure PauseMessages(kind: integer; paused: boolean);
    procedure GenDate;
    function CheckRinged(full: boolean; mess: string): boolean;
    function CheckRinged2(mess: string): boolean;
    function GetSoundDir: string;
    function GetImageDir: string;
    function ECP(str: string): string;
    function DCP(str: string): string;
    function Dir(str: string): string;
    function FilterProfanity(str: string): string;
  end;

var
  Datawell: TDatawell;
  funs, logics: TStringList;

implementation

uses Main, Map;

{$R *.DFM}

procedure TDatawell.DatawellCreate(Sender: TObject);
var i: integer;
begin
// Constant: is this a beta version of the program or not
  betaversion:=true;
// Constant: Portal version (international) 5,100 or 5.000 etc.
  version:='8'+DecimalSeparator+'756';
// Constant: Portal version base (7000, 8000, etc.)
  versionbase:='8000';
// Constant: Portal Homesite
  homesite:='gameaxle';
// Constant: Portal Codesite
  codesite:='mudclient';
// Constant: BDE alias name
  bde:='gtdata';
// Constant: Portal version (decimal 5.100)
  version2:=subs(DecimalSeparator,'.',version);
// Constant: Portal version (no decimal 5000)
  version3:=subs(DecimalSeparator,'',version);
// Constant: identifies the Activator Character preceeded by a ~
  specialcode:='QzYJ';
// Constant: used for further special substitutions
  specialcode2:='XjPZ';
// Constant: and again
  specialcode3:='VxTW';
// Constant: code used for enhanced data
  code:='#K%';
// Constant: delimiter used for the enhanced data elements
  delim:='~';
// Constant: maximum number of chats held for one line
  chatlimit:=1000;
// Constant: maximum number for randomcode
  randommax:=99500;
// Constant: code used to ID the client to the MUD
  randomcode:=0;
// Constant: title used on the printing capabilities
  ptitle:='Portal';
// Constant: cursor used to handpoint
  handpoint:=crHandPoint;
  lastmud:='';                    // last mud
  lastplayer:='';                 // last player
  mud:='';                        // MUD name
  player:='';                     // player name
  password:='';                   // player password
  password2:='';                  // player password2
  bufferpassword:='';             // player password buffer
  cr:='';                         // linefeed/carriage return string
  cr2:='';                        // linefeed/carriage return string (2nd connection)
  chatspaused:=false;             // whether or not chats are paused
  workingoffline:=false;          // used to show if working offline or not
  connected2:=false;              // is/is not a second connection
  script:=TStringList.create;     // contains the login script
  rvars:=TStringList.create;      // lists the reserved variables
  svars:=TStringList.create;      // lists the system variables
  pchats:=TStringList.create;     // holds the buffered chats
  ptells:=TStringList.create;     // holds the buffered tells
  selx:=TStringList.create;
  regmud:='';                     // used for a mud-sponsored registration
  connected:=false;               // connection1 is active or not
  optionpage:=0;                  // options tab the user left it on
  eventpage:=0;                   // events tab the user left it on
  GotData:=false;                 // haven't gotten the data yet
  Mess:=false;                    // show the AD/special message banner (above the toolbar)
  tablessetup:=false;             // options loaded and tables setup
  lastalias:='';
  lastmacro:='';
  lastevent:='';
  lastgroup:='';
  repeatstring:='';
  lastfunction:=0;
  idle:=0;
  disconnected:=false;
  ringed:=false;
  superringed:=false;
  DataFailed:=false;
  abortdata:=false;
  datachecking:=false;
  charting:=false;
  following:=false;
  IPFailed:='';
  gline1:='';
  gline2:='';
  rvars.add('HP');
  rvars.add('MAXHP');
  rvars.add('SP');
  rvars.add('MAXSP');
  rvars.add('GP1');
  rvars.add('MAXGP1');
  rvars.add('GP2');
  rvars.add('MAXGP2');
  rvars.add('ENEMY');
  rvars.add('ENAME');
  rvars.add('GLINE1');
  rvars.add('GLINE2');
  rvars.add('CAPTION');
  rvars.add('AA');
  rvars.add('BB');
  rvars.add('CC');
  rvars.add('DD');
  rvars.add('EE');
  rvars.add('FF');
  svars.add('');
  svars.add('');
  svars.add('');
  svars.add('');
  svars.add('');
  svars.add('');
  funs:=TStringList.create;
  funs.add('set');
  funs.add('math');
  funs.add('random');
  funs.add('cap');
  funs.add('CAP');
  funs.add('lc');
  funs.add('cls');
  funs.add('cts');
  funs.add('cbs');
  funs.add('length');
  funs.add('copy');
  funs.add('delete');
  funs.add('pos');
  funs.add('subs');
  funs.add('abs');
  funs.add('dl');
  funs.add('dt');
  funs.add('sum');
  funs.add('avg');
  funs.add('sqrt');
  funs.add('datetime');
  funs.add('R');
  funs.add('@');
  logics:=TStringList.create;
  logics.add('and');
  logics.add('or');
  logics.add('not');
  playlist:=TStringList.create;
  playindex:=-1;
end;

procedure TDatawell.DatawellDestroy(Sender: TObject);
begin
  script.free;
  rvars.free;
  svars.free;
  funs.free;
  logics.free;
  pchats.free;
  ptells.free;
  selx.free;
  playlist.free;
end;

function TDatawell.CheckRinged(full: boolean; mess: string): boolean;
begin
  result:=true;
end;

function TDatawell.CheckRinged2(mess: string): boolean;
begin
  result:=true;
end;

procedure TDatawell.SetupTables(master: string);
begin
  SetupTables2(TableOptions,master);
  SetupTables2(TableOptions2,master);
  SetupTables2(TableOptions3,master);
  SetupTables2(TableOptions4,master);
  SetupTables2(TableGroups,master);
  SetupTables2(TableRetain,master);
  SetupTables2(TableReverse,master);
  SetupTables2(TableActions,master);
  SetupTables2(TableAliases,master);
  SetupTables2(TableMacros,master);
  SetupTables2(TableMenu,master);
  SetupTables2(TableChat,master);
  SetupTables2(TableChathist,master);
  SetupTables2(TableChatlines,master);
  SetupTables2(TableEvents,master);
  SetupTables2(TableNicknames,master);
  SetupTables2(TableSEvents,master);
  SetupTables2(TableTell,master);
  SetupTables2(TableTellhist,master);
  SetupTables2(TableTells,master);
  SetupTables2(TableTicker,master);
  SetupTables2(TableTools,master);
  SetupTables2(TableVariables,master);
  tablessetup:=true;
end;

procedure TDatawell.SetupTables2(table: TwwTable; master: string);
begin
  with table do begin
    refresh;
    wwfilter.clear;
    wwfilter.add('Master = '+master+'');
    filterActivate;
    active:=true;
  end;
end;

function TDatawell.FigureColor(col: integer): integer;
begin
  result:=0;
  case col of
    0 : result:=clblack;
    1 : result:=clmaroon;
    2 : result:=clgreen;
    3 : result:=clolive;
    4 : result:=clnavy;
    5 : result:=clpurple;
    6 : result:=clteal;
    7 : result:=clsilver;
    8 : result:=clgray;
    9 : result:=clred;
    10: result:=cllime;
    11: result:=clyellow;
    12: result:=clblue;
    13: result:=clfuchsia;
    14: result:=claqua;
    15: result:=clwhite;
  end;
end;

function TDatawell.ColorFigure(col: integer): integer;
begin
  result:=0;
  case col of
    clblack   : result:=0;
    clmaroon  : result:=1;
    clgreen   : result:=2;
    clolive   : result:=3;
    clnavy    : result:=4;
    clpurple  : result:=5;
    clteal    : result:=6;
    clsilver  : result:=7;
    clgray    : result:=8;
    clred     : result:=9;
    cllime    : result:=10;
    clyellow  : result:=11;
    clblue    : result:=12;
    clfuchsia : result:=13;
    claqua    : result:=14;
    clwhite   : result:=15;
  end;
end;

function TDatawell.FigureSound(str: string): string;
var i: integer;
begin
  result:='';
  if str = '' then exit;
  delete(str,length(str)-3,4);
  i:=length(str);
  while str[i] <> '\' do begin
    result:=str[i]+result;
    dec(i);
    if i < 1 then begin
      result:='';
      break;
    end;
  end;
end;

function TDatawell.ValidWord(str: string): boolean;
var i: integer;
begin
  result:=true;
  for i:=1 to length(str) do begin
    if (not (ord(str[i]) >= 65) and (ord(str[i]) <= 90)) and
       (not (ord(str[i]) >= 97) and (ord(str[i]) <= 122)) then begin
      result:=false;
      break;
    end;
  end;
end;

function TDatawell.ValidAlias(str: string): boolean;
var i: integer;
begin
  result:=true;
  if pos(' ',str) > 0 then result:=false
  else if pos('@',str) > 0 then result:=false
  else if pos('$',str) > 0 then result:=false
  else if pos('"',str) > 0 then result:=false
  else if pos('<',str) > 0 then result:=false
  else if pos('>',str) > 0 then result:=false
  else if pos(TableOptions.fieldbyname('Activator').asstring,str) > 0 then result:=false;
  if copy(str,1,1) = '-' then result:=false;
end;

function TDatawell.ToInt(str: string): integer;
var
  i: integer;
  pass, neg: boolean;
  work: string;
begin
  pass:=true;
  neg:=false;
  result:=0;
  work:='0';
  if length(str) < 1 then exit;
  if copy(str,1,1) = ' ' then delete(str,1,1);
  if copy(str,1,1) = '-' then begin
    neg:=true;
    delete(str,1,1);
  end;
  if length(str) > 9 then str:=copy(str,1,9);
  for i:=1 to length(str) do begin
    if (ord(str[i]) >= 48) and (ord(str[i]) <= 57) then work:=work+str[i];
  end;
  if neg then work:='-'+work;
  result:=strtoint(work);
end;

function TDatawell.ToIntPure(str: string): integer;
var
  i: integer;
  pass, neg, invalid: boolean;
  work: string;
begin
  pass:=true;
  neg:=false;
  invalid:=false;
  result:=0;
  work:='0';
  if length(str) < 1 then exit;
  if copy(str,1,1) = ' ' then delete(str,1,1);
  if copy(str,1,1) = '-' then begin
    neg:=true;
    delete(str,1,1);
  end;
  if length(str) > 9 then str:=copy(str,1,9);
  for i:=1 to length(str) do begin
    if (ord(str[i]) >= 48) and (ord(str[i]) <= 57) then work:=work+str[i]
    else invalid:=true;
  end;
  if neg then work:='-'+work;
  result:=strtoint(work);
  if invalid then result:=0;
end;

function TDatawell.ValidWordNumber(str: string): boolean;
var i: integer;
begin
  result:=true;
  for i:=1 to length(str) do begin
    if (not ((ord(str[i]) >= 48) and (ord(str[i]) <= 57))) and
       (not ((ord(str[i]) >= 65) and (ord(str[i]) <= 90))) and
       (not ((ord(str[i]) >= 97) and (ord(str[i]) <= 122))) then begin
      result:=false;
      break;
    end;
  end;
end;

function TDatawell.ANOnly(str: string): string;
var i: integer;
begin
  result:='';
  for i:=1 to length(str) do begin
    if ((ord(str[i]) >= 48) and (ord(str[i]) <= 57)) or
       ((ord(str[i]) >= 97) and (ord(str[i]) <= 122)) then
      result:=result+str[i];
  end;
end;

function TDatawell.ValidLowerWordNumber(str: string): boolean;
var i: integer;
begin
  result:=true;
  for i:=1 to length(str) do begin
    if (not (ord(str[i]) >= 48) and (ord(str[i]) <= 57)) and
       (not (ord(str[i]) >= 97) and (ord(str[i]) <= 122)) then begin
      result:=false;
      break;
    end;
  end;
end;

function TDatawell.Subs(oldstr, newstr, str: string): string;
var i: integer;
begin
  result:=str;
  if oldstr = newstr then exit;
  if pos(oldstr,newstr) > 0 then exit;
  i:=pos(oldstr,str);
  if i < 1 then exit;
  while i > 0 do begin
    insert(newstr,str,i);
    inc(i,length(newstr));
    delete(str,i,length(oldstr));
    i:=pos(oldstr,str);
  end;
  result:=str;
end;

function TDatawell.Nick(str: string): string;
var table: TwwTable;
begin
  result:=str;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=bde;
    tablename:='Nicknames.db';
    wwfilter.assign(TableNicknames.wwfilter);
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      if copy(str,length(str)-length(fieldbyname('Nickname').asstring),
        length(fieldbyname('Nickname').asstring)+1) = ' '+
        fieldbyname('Nickname').asstring then begin
        system.delete(str,length(str)-length(fieldbyname('Nickname').asstring)+1,99999);
        result:=str+fieldbyname('Replacement').asstring;
      end;
      result:=subs(' '+fieldbyname('Nickname').asstring+' ',
        ' '+fieldbyname('Replacement').asstring+' ',result);
      result:=subs(' '+fieldbyname('Nickname').asstring+',',
        ' '+fieldbyname('Replacement').asstring+',',result);
      result:=subs(','+fieldbyname('Nickname').asstring+' ',
        ','+fieldbyname('Replacement').asstring+' ',result);
      result:=subs(','+fieldbyname('Nickname').asstring+',',
        ','+fieldbyname('Replacement').asstring+',',result);
      result:=subs(' '+fieldbyname('Nickname').asstring+'.',
        ' '+fieldbyname('Replacement').asstring+'.',result);
      result:=subs(' '+fieldbyname('Nickname').asstring+'!',
        ' '+fieldbyname('Replacement').asstring+'!',result);
      result:=subs(' '+fieldbyname('Nickname').asstring+'?',
        ' '+fieldbyname('Replacement').asstring+'?',result);
      result:=subs('"'+fieldbyname('Nickname').asstring+'"',
        '"'+fieldbyname('Replacement').asstring+'"',result);
      result:=subs(' '+fieldbyname('Nickname').asstring+'''',
        ' '+fieldbyname('Replacement').asstring+'''',result);
      next;
    end;
  end;
  table.free;
end;

procedure TDatawell.ClearFiltered;
begin
  with TableFiltered do begin
    first;
    while not EOF do delete;
  end;
  FormMain.UpdateFilteredCount;
end;

procedure TDatawell.DeleteFiltered;
begin
  if not TableFiltered.EOF then TableFiltered.delete;
  FormMain.UpdateFilteredCount;
end;

function TDatawell.FigureDate: string;
begin
  result:=FormatDateTime('yyyymmdd',now);
end;

function TDatawell.FigureButton(letter: string): string;
begin
  result:='';
  if letter = 'a' then result:='Exit'
  else if letter = 'b' then result:='Reconnect'
  else if letter = 'c' then result:='Lock Character'
  else if letter = 'd' then result:='Aliases'
  else if letter = 'e' then result:='Macros'
  else if letter = 'f' then result:='Quickchars'
  else if letter = 'g' then result:='Events'
  else if letter = 'h' then result:='Nicknames'
  else if letter = 'j' then result:='View System Messages'
  else if letter = 'k' then result:='Open Autotyper'
  else if letter = 'l' then result:='Autotype'
  else if letter = 'm' then result:='Copy to Clipboard'
  else if letter = 'n' then result:='Copy to Autotyper'
  else if letter = 'o' then result:='Send Text from Clipboard'
  else if letter = 'p' then result:='Reduce Font'
  else if letter = 'q' then result:='Increase Font'
  else if letter = 'r' then result:='Choose Font'
  else if letter = 's' then result:='Program Options'
  else if letter = 't' then result:='Show Tell Monitor'
  else if letter = 'v' then result:='Show Imagery'
  else if letter = 'w' then result:='Help'
  else if letter = 'x' then result:='Panic Button'
  else if letter = 'y' then result:='Clear Scrollback'
  else if letter = 'z' then result:='Customize Toolbar'
  else if letter = '1' then result:='Scrollback'
  else if letter = '2' then result:='Escape'
  else if letter = '4' then result:='Disconnect'
  else if letter = '5' then result:='Clear Keyhistory'
  else if letter = '8' then result:='Capture Scrollback to File'
  else if letter = '9' then result:='Setup Groups'
  else if letter = 'S' then result:='Setup Display Colors'
  else if letter = 'T' then result:='Show Chat Monitor'
  else if letter = 'U' then result:='Log Incoming Text to File'
  else if letter = 'W' then result:='Clear System Messages'
  else if letter = 'X' then result:='Activate the BASE Group'
  else if letter = 'Y' then result:='Ticker'
  else if letter = 'Z' then result:='Find Text'
  else if letter = '!' then result:='Find Next'
  else if letter = '#' then result:='Jumpstart Portal'
  else if letter = 'A' then result:='Custom button 1'
  else if letter = 'B' then result:='Custom button 2'
  else if letter = 'C' then result:='Custom button 3'
  else if letter = 'D' then result:='Custom button 4'
  else if letter = 'E' then result:='Custom button 5'
  else if letter = 'F' then result:='Custom button 6'
  else if letter = 'G' then result:='Custom button 7'
  else if letter = 'H' then result:='Custom button 8'
  else if letter = 'I' then result:='Custom button 9'
  else if letter = 'J' then result:='Custom button 10'
  else if letter = 'K' then result:='Custom button 11'
  else if letter = 'L' then result:='Custom button 12'
  else if letter = 'M' then result:='Copy Download to Autotyper'
  else if letter = 'N' then result:='Capture Download to File'
  else if letter = 'O' then result:='Clear Download'
  else if letter = 'P' then result:='Paste Download into Autotyper'
  else if letter = 'Q' then result:='Upload Files'
  else if letter = 'R' then result:='Graph Paper Generator'
  else if letter = '-' then result:='Variables'
  else if letter = '|' then result:='Cartographer'
  else if letter = ',' then result:='Music Play'
  else if letter = '.' then result:='Music Pause'
  else if letter = '?' then result:='Music Rewind'
  else if letter = '$' then result:='Music Playlist Editor'
  else if letter = '&' then result:='Load Music Playlist'
  else if letter = '%' then result:='Music Previous'
  else if letter = '^' then result:='Music Next'
  else if letter = '*' then result:='Music First'
  else if letter = '(' then result:='Music Last'
  else if letter = '/' then result:='Canvas'
  else if letter = '>' then result:='Quick Event'
  else if letter = '[' then result:='Attempt Secondary Connection'
  else if letter = ']' then result:='Disconnect Secondary Connection'
  else if letter = '{' then result:='Reverse Connection Control'
  else if letter = '}' then result:='Customize Menu Hotkeys'
  else if letter = ':' then result:='Import/Export'
  else if letter = ';' then result:='Send Text File'
  else if letter = '<' then result:='Autoscribble';
end;

function TDatawell.FigureLetter(button: string): string;
begin
  result:='';
  if button = 'Exit' then result:='a'
  else if button = 'Reconnect' then result:='b'
  else if button = 'Lock Character' then result:='c'
  else if button = 'Aliases' then result:='d'
  else if button = 'Macros' then result:='e'
  else if button = 'Quickchars' then result:='f'
  else if button = 'Events' then result:='g'
  else if button = 'Nicknames' then result:='h'
  else if button = 'View System Messages' then result:='j'
  else if button = 'Open Autotyper' then result:='k'
  else if button = 'Autotype' then result:='l'
  else if button = 'Copy to Clipboard' then result:='m'
  else if button = 'Copy to Autotyper' then result:='n'
  else if button = 'Send Text from Clipboard' then result:='o'
  else if button = 'Reduce Font' then result:='p'
  else if button = 'Increase Font' then result:='q'
  else if button = 'Choose Font' then result:='r'
  else if button = 'Program Options' then result:='s'
  else if button = 'Show Tell Monitor' then result:='t'
  else if button = 'Show Imagery' then result:='v'
  else if button = 'Help' then result:='w'
  else if button = 'Panic Button' then result:='x'
  else if button = 'Clear Scrollback' then result:='y'
  else if button = 'Customize Toolbar' then result:='z'
  else if button = 'Scrollback' then result:='1'
  else if button = 'Escape' then result:='2'
  else if button = 'Disconnect' then result:='4'
  else if button = 'Clear Keyhistory' then result:='5'
  else if button = 'Capture Scrollback to File' then result:='8'
  else if button = 'Setup Groups' then result:='9'
  else if button = 'Setup Display Colors' then result:='S'
  else if button = 'Show Chat Monitor' then result:='T'
  else if button = 'Log Incoming Text to File' then result:='U'
  else if button = 'Clear System Messages' then result:='W'
  else if button = 'Activate the BASE Group' then result:='X'
  else if button = 'Ticker' then result:='Y'
  else if button = 'Find Text' then result:='Z'
  else if button = 'Find Next' then result:='!'
  else if button = 'Jumpstart Portal' then result:='#'
  else if button = 'Custom Button 1' then result:='A'
  else if button = 'Custom Button 2' then result:='B'
  else if button = 'Custom Button 3' then result:='C'
  else if button = 'Custom Button 4' then result:='D'
  else if button = 'Custom Button 5' then result:='E'
  else if button = 'Custom Button 6' then result:='F'
  else if button = 'Custom Button 7' then result:='G'
  else if button = 'Custom Button 8' then result:='H'
  else if button = 'Custom Button 9' then result:='I'
  else if button = 'Custom Button 10' then result:='J'
  else if button = 'Custom Button 11' then result:='K'
  else if button = 'Custom Button 12' then result:='L'
  else if button = 'Copy Download to Autotyper' then result:='M'
  else if button = 'Capture Download to File' then result:='N'
  else if button = 'Clear Download' then result:='O'
  else if button = 'Paste Download into Autotyper' then result:='P'
  else if button = 'Upload Files' then result:='Q'
  else if button = 'Graph Paper Generator' then result:='R'
  else if button = 'Variables' then result:='-'
  else if button = 'Cartographer' then result:='|'
  else if button = 'Music Play' then result:=','
  else if button = 'Music Pause' then result:='.'
  else if button = 'Music Rewind' then result:='?'
  else if button = 'Music Playlist Editor' then result:='$'
  else if button = 'Load Music Playlist' then result:='&'
  else if button = 'Music Previous' then result:='%'
  else if button = 'Music Next' then result:='^'
  else if button = 'Music First' then result:='*'
  else if button = 'Music Last' then result:='('
  else if button = 'Canvas' then result:='/'
  else if button = 'Quick Event' then result:='>'
  else if button = 'Attempt Secondary Connection' then result:='['
  else if button = 'Disconnect Secondary Connection' then result:=']'
  else if button = 'Reverse Connection Control' then result:='{'
  else if button = 'Customize Menu Hotkeys' then result:='}'
  else if button = 'Import/Export' then result:=':'
  else if button = 'Send Text File' then result:=';'
  else if button = 'Autoscribble' then result:='<';
end;

function TDatawell.CutLeadingSpaces(data: string): string;
begin
  while copy(data,1,1) = ' ' do delete(data,1,1);
  result:=data;
end;

function TDatawell.CutTrailingSpaces(data: string): string;
begin
  while copy(data,length(data),1) = ' ' do data:=copy(data,1,length(data)-1);
  result:=data;
end;

function TDatawell.CutAllSpaces(data: string): string;
begin
  while pos(' ',data) > 0 do delete(data,pos(' ',data),1);
  result:=data;
end;

function TDatawell.CheckAllSpaces(data: string): string;
begin
  result:=data;
  while pos(' ',data) > 0 do delete(data,pos(' ',data),1);
  if data = '' then result:='';
end;

function TDatawell.FigureSoundFile(data: string): string;
var i: integer;
begin
  result:='';
  if data = '' then exit;
  delete(data,length(data)-3,4);
  i:=length(data);
  while data[i] <> '\' do begin
    result:=data[i]+result;
    dec(i);
  end;
end;

function TDatawell.Cap(data: string): string;
begin
  result:=lowercase(data);
  result:=uppercase(copy(result,1,1))+copy(result,2,9999);
end;

function TDatawell.Reverse(data: string): string;
var
  table: TwwTable;
  didfind: boolean;
begin
  result:='';
  data:=subs('"','',data);
  didfind:=false;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=bde;
    tablename:='Reverse.db';
    wwfilter.assign(TableReverse.wwfilter);
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      if fieldbyname('Command').asstring = data then begin
        didfind:=true;
        break;
      end;
      next;
    end;
    if didfind then result:=fieldbyname('Reverse').asstring;
  end;
  table.free;
end;

function TDatawell.ReplaceVariables(str: string): string;
var
  i: integer;
  table: TwwTable;
begin
  result:=str;
  result:=subs('@@@',specialcode2,result);
  result:=subs('@@',specialcode,result);
  result:=subs(specialcode2,'@@',result);
  //User-derined variables
  table:=TwwTable.create(self);
  with table do begin
    databasename:=bde;
    tablename:='Variables.db';
    wwfilter.assign(TableVariables.wwfilter);
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      result:=subs('@'+fieldbyname('Variable').asstring,
        fieldbyname('Value').asstring,result);
      next;
    end;
  end;
  table.free;
  //System variables
  result:=subs('@HP',FormMain.LabelHP.caption,result);
  result:=subs('@MAXHP',FormMain.LabelHPMax.caption,result);
  result:=subs('@SP',FormMain.LabelSP.caption,result);
  result:=subs('@MAXSP',FormMain.LabelSPMax.caption,result);
  result:=subs('@GP1',FormMain.LabelGP1.caption,result);
  result:=subs('@MAXGP1',FormMain.LabelGP1Max.caption,result);
  result:=subs('@GP2',FormMain.LabelGP2.caption,result);
  result:=subs('@MAXGP2',FormMain.LabelGP2Max.caption,result);
  result:=subs('@ENEMY',inttostr(FormMain.GaugeEnemy.progress),result);
  result:=subs('@ENAME',FormMain.GetEName,result);
  result:=subs('@GLINE1',gline1,result);
  result:=subs('@GLINE2',gline2,result);
  result:=subs('@CAPTION',FormMain.caption,result);
  result:=subs('@AA',svars[0],result);
  result:=subs('@BB',svars[1],result);
  result:=subs('@CC',svars[2],result);
  result:=subs('@DD',svars[3],result);
  result:=subs('@EE',svars[4],result);
  result:=subs('@FF',svars[5],result);
  //References
  result:=subs('@TICKER',FormMain.LabelTicker.caption,result);
  result:=subs('@TIME',timetostr(now),result);
  result:=subs('@DATE',datetostr(now),result);
  result:=subs('@CHARTING',IsCharting,result);
  result:=subs('@FOLLOWING',IsFollowing,result);
  result:=subs('@ROOM',FormMain.roomshortstring,result);
  result:=subs('@PANIC',IsPanicking,result);
  result:=subs(specialcode,'@',result);
end;

procedure TDatawell.UpdateVariable(variable, value: string);
var
  i, x: integer;
  table: TwwTable;
begin
  delete(variable,1,1);
  value:=copy(value,1,250);
  if variable = 'AA' then svars[0]:=value
  else if variable = 'BB' then svars[1]:=value
  else if variable = 'CC' then svars[2]:=value
  else if variable = 'DD' then svars[3]:=value
  else if variable = 'EE' then svars[4]:=value
  else if variable = 'FF' then svars[5]:=value
  else begin
    i:=rvars.indexof(variable);
    if (i >= 0) and (variable = rvars[i]) then
      FormMain.Compile('@'+rvars[i]+'='+value)
    else begin
      x:=ToInt(value);
      if x > 999999999 then value:='999999999';
      if x < -999999999 then value:='-999999999';
      table:=TwwTable.create(self);
      with table do begin
        databasename:=bde;
        tablename:='Variables.db';
        wwfilter.assign(TableVariables.wwfilter);
        filterActivate;
        active:=true;
        first;
        while not EOF do begin
          if fieldbyname('Variable').asstring = variable then begin
            edit;
            fieldbyname('Value').asstring:=value;
            post;
            break;
          end;
          next;
        end;
      end;
      table.free;
    end;
  end;
  TableVariables.refresh;
end;

procedure TDatawell.Explode(str, element: string; var SL: TStringList);
var i, el: integer;
begin
  SL.clear;
  if str = '' then exit;
  el:=length(element);
  i:=pos(element,str);
  if i < 1 then SL.add(str)
  else begin
    while i > 0 do begin
      SL.add(copy(str,1,i-1));
      delete(str,1,i+el-1);
      i:=pos(element,str);
    end;
    SL.add(str);
  end;
end;

function TDatawell.IsMacro(str: string): boolean;
var table: TwwTable;
begin
  result:=false;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=bde;
    tablename:='Macros.db';
    wwfilter.assign(TableMacros.wwfilter);
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      if str = fieldbyname('Macro').asstring then begin
        result:=true;
        break;
      end;
      next;
    end;
  end;
  table.free;
end;

function TDatawell.IsAlias(str: string): boolean;
var table: TwwTable;
begin
  result:=false;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=bde;
    tablename:='Aliases.db';
    wwfilter.assign(TableAliases.wwfilter);
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      if str = fieldbyname('Alias').asstring then begin
        result:=true;
        break;
      end;
      next;
    end;
  end;
  table.free;
end;

function TDatawell.FigureQuickchar(str: string): string;
var table: TwwTable;
begin
  table:=TwwTable.create(self);
  with table do begin
    databasename:=bde;
    tablename:='Actions.db';
    wwfilter.clear;
    wwfilter.add('(Master = '+masterindex+')');
    wwfilter.add('(Character = "'+str+'")');
    filterActivate;
    active:=true;
    result:=fieldbyname('Action').asstring;
  end;
  table.free;
end;

function TDatawell.ReplaceFunctions(str: string): string;
var
  pre, pro, work: string;
  i, j, q, l, parents: integer;
  done: boolean;
begin
  done:=false;
  while not done do begin
    done:=true;
    for j:=0 to funs.count-1 do begin
      i:=pos(funs[j]+'(',str);
      if i < 1 then continue;
      pre:=copy(str,1,i-1);
      work:=copy(str,i+length(funs[j])+1,99999);
      q:=0;
      parents:=1;
      l:=length(work);
      while (parents > 0) and (q < l) do begin
        inc(q);
        if copy(work,q,1) = '(' then inc(parents);
        if copy(work,q,1) = ')' then dec(parents);
      end;
      pro:=copy(work,q+1,99999);
      delete(work,q,99999);
      work:=ReplaceFunctions(work);
      work:=FormMain.DoFunction(funs[j]+'('+work+')');
      str:=pre+work+pro;
      done:=false;
    end;
  end;
  result:=str;
end;

function TDatawell.FigureLogic(str: string): boolean;
var
  pre, pro: string;
  i, k, l, v1, v2: integer;
begin
  result:=false;
  k:=0;
  i:=pos('<>',str);
  if i > 0 then k:=1
  else begin
    i:=pos('>=',str);
    if i > 0 then k:=2
    else begin
      i:=pos('<=',str);
      if i > 0 then k:=3
      else begin
        i:=pos('>',str);
        if i > 0 then k:=4
        else begin
          i:=pos('<',str);
          if i > 0 then k:=5
          else begin
            i:=pos('=',str);
            if i > 0 then k:=6;
          end;
        end;
      end;
    end;
  end;
  case k of 1: l:=2; 2: l:=2; 3: l:=2; 4: l:=1; 5: l:=1; 6: l:=1; end;
  pre:=CutTrailingSpaces(copy(str,1,i-1));
  pro:=CutLeadingSpaces(copy(str,i+l,99999));
  case k of
    0: if (str <> '0') and (str <> '') then result:=true;
    1: if pre <> pro then result:=true;
    2: begin
         v1:=ToInt(pre);
         v2:=ToInt(pro);
         if (v1 = 0) and (v2 = 0) then begin
           if pre >= pro then result:=true;
         end
         else begin
           if ToInt(pre) >= ToInt(pro) then result:=true;
         end;
       end;
    3: begin
         v1:=ToInt(pre);
         v2:=ToInt(pro);
         if (v1 = 0) and (v2 = 0) then begin
           if pre <= pro then result:=true;
         end
         else begin
           if ToInt(pre) <= ToInt(pro) then result:=true;
         end;
       end;
    4: begin
         v1:=ToInt(pre);
         v2:=ToInt(pro);
         if (v1 = 0) and (v2 = 0) then begin
           if pre > pro then result:=true;
         end
         else begin
           if ToInt(pre) > ToInt(pro) then result:=true;
         end;
      end;
    5: begin
         v1:=ToInt(pre);
         v2:=ToInt(pro);
         if (v1 = 0) and (v2 = 0) then begin
           if pre < pro then result:=true;
         end
         else begin
           if ToInt(pre) < ToInt(pro) then result:=true;
         end;
       end;
    6: if pre = pro then result:=true;
  end;
end;

function TDatawell.IsLogical(str: string): string;
var
  pre, pro, arg1, arg2, work, logic: string;
  i, j, p, q, l, parents: integer;
  done: boolean;
begin
  done:=false;
  while not done do begin
    done:=true;
    for j:=0 to logics.count-1 do begin
      i:=pos(logics[j]+'(',str);
      if i < 1 then continue;
      pre:=copy(str,1,i-1);
      work:=copy(str,i+length(logics[j])+1,99999);
      q:=0;
      parents:=1;
      l:=length(work);
      while (parents > 0) and (q < l) do begin
        inc(q);
        if copy(work,q,1) = '(' then inc(parents);
        if copy(work,q,1) = ')' then dec(parents);
      end;
      pro:=copy(work,q+1,99999);
      delete(work,q,99999);
      work:=IsLogical(work);
      p:=pos(',',work);
      arg1:=copy(work,1,p-1);
      arg2:=copy(work,p+1,99999);
      logic:='0';
      if logics[j] = 'and' then begin
        if FigureLogic(arg1) and FigureLogic(arg2) then logic:='1'
      end
      else if logics[j] = 'or' then begin
        if FigureLogic(arg1) or FigureLogic(arg2) then logic:='1'
      end
      else begin
        if not FigureLogic(work) then logic:='1=1' else logic:='1=0';
      end;
      str:=pre+logic+pro;
      done:=false;
    end;
  end;
  result:=str;
end;

function TDatawell.DoLogic(str: string): boolean;
var
  i: integer;
  notting :boolean;
begin
  result:=false;
  notting:=false;
  while copy(str,1,4) = 'not(' do begin
    delete(str,1,4);
    delete(str,length(str),1);
    notting:=not notting;
  end;
  i:=pos('and(',str);
  if i < 1 then i:=pos('or(',str);
  if i > 0 then begin
    if (IsLogical(str) = '1') or (lowercase(str) = 'true') or (lowercase(str) = 't') then result:=true;
    if notting then result:=not result;
    exit;
  end;
  result:=FigureLogic(str);
  if notting then result:=not result;
end;

function TDatawell.EXE(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  result:=ShellExecute(Application.MainForm.Handle,nil,
    strpcopy(zFileName,FileName),strpcopy(zParams,Params),
    strpcopy(zDir,DefaultDir),showcmd);
end;

function TDatawell.RandomLetter: string;
begin
  result:='z';
  case random(26) of
    0: result:='a';
    1: result:='b';
    2: result:='c';
    3: result:='d';
    4: result:='e';
    5: result:='f';
    6: result:='g';
    7: result:='h';
    8: result:='i';
    9: result:='j';
    10: result:='k';
    11: result:='l';
    12: result:='m';
    13: result:='n';
    14: result:='o';
    15: result:='p';
    16: result:='q';
    17: result:='r';
    18: result:='s';
    19: result:='t';
    20: result:='u';
    21: result:='v';
    22: result:='w';
    23: result:='x';
    24: result:='y';
    25: result:='z';
  end;
end;

function TDatawell.CorrectPunctuation(str: string): string;
begin
  result:=str+' ';
  result:=subs(' i ',' I ',result);
  result:=subs(' im ',' I''m ',result);
  result:=subs(' ive ',' I''ve ',result);
  result:=subs(' dont ',' don''t ',result);
  result:=subs(' wont ',' won''t ',result);
  result:=subs(' cant ',' can''t ',result);
  result:=subs(' didnt ',' didn''t ',result);
  result:=subs(' shouldnt ',' shouldn''t ',result);
  result:=subs(' couldnt ',' couldn''t ',result);
  result:=subs(' doesnt ',' doesn''t ',result);
  result:=subs(' ain''t ',' isn''t ',result);
  result:=subs(' aint ',' isn''t ',result);
  result:=subs(' arent ',' aren''t ',result);
  delete(result,length(result),1);
end;

function TDatawell.CheckIP(ip: string): boolean;
var
  ips: TStringList;
  i, p: integer;
  s1, s2, s3, s4, r1, r2, r3, r4, work: string;
begin
  result:=true;
  ips:=TStringList.create;
  ips.assign(wsocket.localiplist);
  work:=ip;
  p:=pos('.',work);
  s1:=copy(work,1,p-1);
  delete(work,1,p);
  p:=pos('.',work);
  s2:=copy(work,1,p-1);
  delete(work,1,p);
  p:=pos('.',work);
  s3:=copy(work,1,p-1);
  delete(work,1,p);
  s4:=work;
  for i:=0 to ips.count-1 do begin
    work:=ips[i];
    p:=pos('.',work);
    r1:=copy(work,1,p-1);
    delete(work,1,p);
    p:=pos('.',work);
    r2:=copy(work,1,p-1);
    delete(work,1,p);
    p:=pos('.',work);
    r3:=copy(work,1,p-1);
    delete(work,1,p);
    r4:=work;
    if (s4 = '*') and (s3 = '*') and (s2 = '*') then begin
      if s1 = r1 then result:=false;
    end
    else if (s4 = '*') and (s3 = '*') then begin
      if (s1 = r1) and (s2 = r2) then result:=false;
    end
    else if s4 = '*' then begin
      if (s1 = r1) and (s2 = r2) and (s3 = r3) then result:=false;
    end
    else begin
      if (s1 = r1) and (s2 = r2) and (s3 = r3) and (s4 = r4) then result:=false;
    end;
    if not result then break;
  end;
  ips.free;
end;

function TDatawell.FigureID: string;
var
  element, work: string;
  i: integer;
begin
  result:='';
  work:=TableGlobals.fieldbyname('Disperse').asstring;
  for i:=1 to 10 do begin
    element:=copy(work,1,2);
    delete(work,1,2);
    result:=char(toint(element))+result;
  end;
end;

function TDatawell.FigureID2: string;
var
  s1, s2, s3, s5, s6, s7, sl: string;
  s: integer;
begin
  s:=disksize(3);
  sl:=inttostr(length(inttostr(s)));
  s1:=copy(inttostr(s),1,1);
  s2:=copy(inttostr(s),2,1);
  s3:=copy(inttostr(s),3,1);
  s5:=copy(inttostr(s),5,1);     
  s6:=copy(inttostr(s),6,1);
  s7:=copy(inttostr(s),7,1);
  result:=s1+s2+s3+s5+s6+s7+sl;
end;

function TDatawell.GetDir(which: integer): string;
begin
  case which of
    1: result:=TableGlobals.fieldbyname('Dir1').asstring; //Player profiles
    2: result:=TableGlobals.fieldbyname('Dir2').asstring; //Autotyper files
    3: result:=TableGlobals.fieldbyname('Dir3').asstring; //Cartographer files
    4: result:=TableGlobals.fieldbyname('Dir4').asstring; //Captured scrollback files
    5: result:=TableGlobals.fieldbyname('Dir5').asstring; //Sound Files Up/Downloaded files
    6: result:=TableGlobals.fieldbyname('Dir6').asstring; //Other-client import files
  end;
  if not directoryexists(result) then result:=SetDir(which,result);
end;

function TDatawell.SetDir(which: integer; dir: string): string;
var work: string;
begin
  if not directoryexists(dir) then begin
    work:=dir+'\';
    if not directoryexists(work) then dir:=extractfiledir(dir);
    if not directoryexists(dir) then dir:=exedir;
  end;  
  TableGlobals.edit;
  case which of
    1: TableGlobals.fieldbyname('Dir1').asstring:=dir;
    2: TableGlobals.fieldbyname('Dir2').asstring:=dir;
    3: TableGlobals.fieldbyname('Dir3').asstring:=dir;
    4: TableGlobals.fieldbyname('Dir4').asstring:=dir;
    5: TableGlobals.fieldbyname('Dir5').asstring:=dir;
    6: TableGlobals.fieldbyname('Dir6').asstring:=dir;
  end;
  TableGlobals.post;
  result:=dir;
end;

function TDatawell.NewExitOrder(map: string; x, y: integer): integer;
var table: TwwTable;
begin
  result:=1000;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=bde;
    tablename:='Exits.db';
    wwfilter.clear;
    wwfilter.add('(Map = "'+map+'")');
    wwfilter.add('(X = '+inttostr(x)+')');
    wwfilter.add('(Y = '+inttostr(y)+')');
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      if fieldbyname('Order').asinteger < result then
        result:=fieldbyname('Order').asinteger;
      next;
    end;
  end;
  table.free;
  dec(result);
end;

function TDatawell.IsMap(map: string): boolean;
var table: TwwTable;
begin
  result:=false;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=bde;
    tablename:='Maps.db';
    wwfilter.clear;
    wwfilter.add('(Map = "'+map+'")');
    filterActivate;
    active:=true;
    first;
    result:=not EOF;
  end;
  table.free;
end;

function TDatawell.IsCharting: string;
begin
  if charting then result:='1' else result:='0';
end;

function TDatawell.IsFollowing: string;
begin
  if following then result:='1' else result:='0';
end;

function TDatawell.IsPanicking: string;
begin
  if FormMain.panicking then result:='1' else result:='0';
end;

function TDatawell.SearchWell(str: string): string;
var work: string;
begin
  result:='';
  if str = '' then exit;
  work:=TableOptions3.fieldbyname('S56').asstring;
  if copy(work,1,length(str)) = str then result:=work;
  if result = '' then begin
    work:=TableOptions3.fieldbyname('S57').asstring;
    if copy(work,1,length(str)) = str then result:=work;
  end;
  if result = '' then begin
    work:=TableOptions3.fieldbyname('S58').asstring;
    if copy(work,1,length(str)) = str then result:=work;
  end;
  if result = '' then begin
    work:=TableOptions3.fieldbyname('S59').asstring;
    if copy(work,1,length(str)) = str then result:=work;
  end;
  if result = '' then begin
    work:=TableOptions3.fieldbyname('S60').asstring;
    if copy(work,1,length(str)) = str then result:=work;
  end;
end;

procedure TDatawell.AddChat(cmd, line, who, mess: string);
var
  didfind, overflow: boolean;
  i, j: integer;
  tablech, tablec: TwwTable;
begin
  if (line = '') or (mess = '') then exit;
  mess:=subs('^^','~',mess);
  line:=subs('"','',line);
  line:=copy(line,1,60);
  if chatspaused then begin
    pchats.add(cmd+specialcode+line+specialcode+who+specialcode+mess);
    exit;
  end;
  mess:=subs(#7,'',mess);
  mess:=subs(#9,'',mess);
  didfind:=false;
  overflow:=false;
  tablec:=TwwTable.create(self);
  with tablec do begin
    databasename:=bde;
    tablename:='Chat.db';
    wwfilter.clear;
    wwfilter.add('(Master = '+masterindex+')');
    wwfilter.add('(LINE = "'+line+'")');
    filterActivate;
    active:=true;
    if fieldbyname('Line').asstring <> '' then begin
      j:=fieldbyname('FullAmt').asinteger;
      inc(j);
      if j > 999 then j:=1;
      edit;
      fieldbyname('FullAmt').asinteger:=j;
      if j > chatlimit then overflow:=true
      else begin
        i:=fieldbyname('Amt').asinteger;
        inc(i);
        fieldbyname('Amt').asinteger:=i;
      end;
      post;
    end
    else begin
      append;
      fieldbyname('Master').asinteger:=masterinteger;
      fieldbyname('Line').asstring:=line;
      fieldbyname('Command').asstring:=cmd;
      fieldbyname('Amt').asinteger:=1;
      fieldbyname('FullAmt').asinteger:=1;
      post;
    end;
  end;
  TableChat.refresh;
  if overflow then begin
    tablech:=TwwTable.create(self);
    with tablech do begin
      databasename:=bde;
      tablename:='Chathist.db';
      wwfilter.clear;
      wwfilter.add('(Master = '+masterindex+')');
      wwfilter.add('(LINE = "'+tablec.fieldbyname('Line').asstring+'")');
      filterActivate;
      active:=true;
      first;
      delete;
    end;
    tablech.free;
    TableChathist.refresh;
  end;
  TableChathist.append;
  TableChathist.fieldbyname('Master').asinteger:=masterinteger;
  TableChathist.fieldbyname('Command').asstring:=cmd;
  TableChathist.fieldbyname('Line').asstring:=line;
  TableChathist.fieldbyname('From').asstring:=who;
  TableChathist.fieldbyname('Message').asstring:=mess;
  TableChathist.fieldbyname('Index').asinteger:=tablec.fieldbyname('FullAmt').asinteger;
  tablec.free;
  try TableChathist.post;
    except on EDBEngineError do TableChathist.cancel;
  end;
  didfind:=false;
  with TableChatlines do begin
    first;
    while not EOF do begin
      if TableChatlines.fieldbyname('Line').asstring = line then begin
        didfind:=true;
        break;
      end;
      next;
    end;
    if didfind then begin
      if fieldbyname('Command').asstring <> cmd then begin
        edit;
        fieldbyname('Command').asstring:=cmd;
        post;
      end;
      exit;
    end
    else begin
      append;
      TableChatlines.fieldbyname('Master').asinteger:=masterinteger;
      TableChatlines.fieldbyname('Line').asstring:=line;
      TableChatlines.fieldbyname('Mask').asstring:=line;
      TableChatlines.fieldbyname('Command').asstring:=cmd;
      TableChatlines.fieldbyname('FGColor').asinteger:=clblack;
      TableChatlines.fieldbyname('BGColor').asinteger:=clsilver;
      try TableChatlines.post;
        except on EDBEngineError do TableChatlines.cancel;
      end;
    end;
  end;
end;

procedure TDatawell.AddTell(me, from, mess: string);
var
  didfind: boolean;
  i: integer;
  table: TwwTable;
begin
  if (from = '') or (mess = '') then exit;
  mess:=subs('^^','~',mess);
  from:=subs('"','',from);
  from:=copy(from,1,60);
  if tellspaused then begin
    ptells.add(me+specialcode+from+specialcode+mess);
    exit;
  end;
  mess:=subs(#7,'',mess);
  mess:=subs(#9,'',mess);
  didfind:=false;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=bde;
    tablename:='Tell.db';
    wwfilter.clear;
    wwfilter.add('Master = '+masterindex);
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      if fieldbyname('From').asstring = from then begin
        didfind:=true;
        break;
      end;
      next;
    end;
    if didfind then begin
      i:=fieldbyname('Amt').asinteger;
      inc(i);
      if i > 999 then i:=1;
      edit;
      fieldbyname('Amt').asinteger:=i;
      post;
    end
    else begin
      append;
      fieldbyname('Master').asinteger:=masterinteger;
      fieldbyname('From').asstring:=from;
      fieldbyname('Amt').asinteger:=1;
      post;
    end;
  end;
  TableTell.refresh;
  TableTellhist.append;
  TableTellhist.fieldbyname('Master').asinteger:=masterinteger;
  if me <> '' then begin
    TableTellhist.fieldbyname('From').asstring:='To: '+from;
    TableTellhist.fieldbyname('Mine').asstring:=from;
  end
  else TableTellhist.fieldbyname('From').asstring:=from;
  TableTellhist.fieldbyname('From1').asstring:=from;
  TableTellhist.fieldbyname('Message').asstring:=mess;
  TableTellhist.fieldbyname('Index').asinteger:=table.fieldbyname('Amt').asinteger;
  table.free;
  try TableTellhist.post; except on EDBEngineError do TableTellhist.cancel; end;
end;

procedure TDatawell.PauseMessages(kind: integer; paused: boolean);
var
  i, p: integer;
  work, Bcmd, Bline, Bwho, Bmess, Bme, Bfrom: string;
begin
  if kind = 0 then begin
    if paused then chatspaused:=true
    else begin
      chatspaused:=false;
      for i:=0 to pchats.count-1 do begin
        work:=pchats[i];
        p:=pos(specialcode,work);
        Bcmd:=copy(work,1,p-1);
        delete(work,1,p+length(specialcode)-1);
        p:=pos(specialcode,work);
        Bline:=copy(work,1,p-1);
        delete(work,1,p+length(specialcode)-1);
        p:=pos(specialcode,work);
        Bwho:=copy(work,1,p-1);
        delete(work,1,p+length(specialcode)-1);
        Bmess:=work;
        AddChat(Bcmd,Bline,Bwho,Bmess);
      end;
      pchats.clear;
    end;
  end
  else begin
    if paused then tellspaused:=true
    else begin
      tellspaused:=false;
      for i:=0 to ptells.count-1 do begin
        work:=ptells[i];
        p:=pos(specialcode,work);
        Bme:=copy(work,1,p-1);
        delete(work,1,p+length(specialcode)-1);
        p:=pos(specialcode,work);
        Bfrom:=copy(work,1,p-1);
        delete(work,1,p+length(specialcode)-1);
        Bmess:=work;
        AddTell(Bme,Bfrom,Bmess);
      end;
      ptells.clear;
    end;
  end;
end;

procedure TDatawell.GenDate;
var
  str, work: string;
  amt: integer;
begin
  if TableGlobals.fieldbyname('S2').asstring <> '' then exit;
//m/d/y +50*4,+60*3,-1853*2
  str:='ScreenSize,'+inttostr(random(100));
  work:=formatdatetime('m',now);
  amt:=toint(work);
  amt:=(amt+50)*4;
  str:=str+','+inttostr(amt);
  work:=formatdatetime('d',now);
  amt:=toint(work);
  amt:=(amt+60)*3;
  str:=str+','+inttostr(amt);
  work:=formatdatetime('yyyy',now);
  amt:=toint(work);
  amt:=(amt-1853)*2;
  str:=str+','+inttostr(amt);
  TableGlobals.edit;
  TableGlobals.fieldbyname('S2').asstring:=str;
  TableGlobals.post;
end;

function TDatawell.GetSoundDir: string;
begin
  result:=TableGlobals.fieldbyname('S21').asstring;
  if (result = '') or (not directoryexists(result)) then result:=exedir+'\media\sounds\';
end;

function TDatawell.GetImageDir: string;
begin
  result:=TableGlobals.fieldbyname('S22').asstring;
  if (result = '') or (not directoryexists(result)) then result:=exedir+'\media\images\';
end;

function TDatawell.ECP(str: string): string;
var
  i, x, t: integer;
  work: string;
begin
  work:='';
  while length(str) > 0 do begin
    i:=ord(str[1]);
    if i < 100 then work:=work+'0'+inttostr(i)
    else work:=work+inttostr(i);
    delete(str,1,1);
  end;
  str:=work;
  work:='';
  while length(str) > 0 do begin
    i:=toint(copy(str,1,1))*3;
    if i < 10 then work:=work+'0'+inttostr(i)
    else work:=work+inttostr(i);
    delete(str,1,1);
  end;
  result:='|||';
  i:=1;
  while length(work) > 0 do begin
    x:=toint(copy(work,1,1));
    case x of
      0: t:=1;
      1: t:=0;
      2: t:=9;
      3: t:=4;
      4: t:=7;
      5: t:=8;
      6: t:=5;
      7: t:=2;
      8: t:=6;
      9: t:=3;
    end;
    result:=result+inttostr(t);
    if (i mod 4) = 0 then result:=result+inttostr(random(10));
    delete(work,1,1);
    inc(i);
  end;
  result:=subs('11','z',result);
  result:=subs('7','y',result);
  result:=subs('0','7',result);
end;

function TDatawell.DCP(str: string): string;
var
  i, x, t: integer;
  work: string;
begin
  result:=str;
  if copy(str,1,3) <> '|||' then exit;
  delete(str,1,3);
  str:=subs('z','11',str);
  str:=subs('7','0',str);
  str:=subs('y','7',str);
  work:='';
  i:=1;
  while length(str) > 0 do begin
    if (i mod 5) <> 0 then work:=work+copy(str,1,1);
    inc(i);
    delete(str,1,1);
  end;
  str:=work;
  work:='';
  while length(str) > 0 do begin
    x:=toint(copy(str,1,1));
    case x of
      0: t:=1;
      1: t:=0;
      2: t:=7;
      3: t:=9;
      4: t:=3;
      5: t:=6;
      6: t:=8;
      7: t:=4;
      8: t:=5;
      9: t:=2;
    end;
    work:=work+inttostr(t);
    delete(str,1,1);
  end;
  str:=work;
  work:='';
  while length(str) > 0 do begin
    x:=toint(copy(str,1,2)) div 3;
    work:=work+inttostr(x);
    delete(str,1,2);
  end;
  result:='';
  while length(work) > 0 do begin
    x:=toint(copy(work,1,3));
    result:=result+chr(x);
    delete(work,1,3);
  end;
end;

function TDatawell.CutAllOfOneChar(cut, data: string): string;
begin
  while pos(cut,data) > 0 do delete(data,pos(cut,data),1);
  result:=data;
end;

procedure TDatawell.Help(helpfile: string);
var help: TStringList;
begin
  helpfile:=lowercase(helpfile);
  helpfile:=subs(' ','_',helpfile);
  help:=TStringList.create;
  help.add('<HTML>');
  help.add('<HEAD>');
  help.add('<TITLE>Portal for Windows Help</TITLE>');
  help.add('</HEAD>');
  help.add('<Frameset Cols=190,*>');
    help.add('<Frame name="left" src="left.html" scrolling="auto">');
    help.add('<Frame name="main" src="'+helpfile+'.html" scrolling="auto">');
  help.add('</Frameset>');
  help.add('</HTML>');
  helpfile:=exedir+'\help\main.html';
  try help.savetofile(helpfile);
    except on EFOpenError do begin
      messagedlg('The file is locked by another application',mtinformation,[mbok],0);
      help.free;
      exit;
    end;
  end;
  help.free;
  if not FileExists(helpfile) then begin
    messagedlg('The help file does not exit',mtinformation,[mbok],0);
    exit;
  end;
  EXE(helpfile,'','c:\',SW_SHOW);
end;

function TDatawell.Dir(str: string): string;
begin
  with TableGlobals2 do begin
    if str = 'up' then result:=fieldbyname('Up').asstring
    else if str = 'down' then result:=fieldbyname('Down').asstring
    else if str = 'northwest' then result:=fieldbyname('Northwest').asstring
    else if str = 'north' then result:=fieldbyname('North').asstring
    else if str = 'northeast' then result:=fieldbyname('Northeast').asstring
    else if str = 'west' then result:=fieldbyname('West').asstring
    else if str = 'east' then result:=fieldbyname('East').asstring
    else if str = 'southwest' then result:=fieldbyname('Southwest').asstring
    else if str = 'south' then result:=fieldbyname('South').asstring
    else if str = 'southeast' then result:=fieldbyname('Southeast').asstring
    else if str = 'u' then result:=fieldbyname('U').asstring
    else if str = 'd' then result:=fieldbyname('D').asstring
    else if str = 'nw' then result:=fieldbyname('NW').asstring
    else if str = 'n' then result:=fieldbyname('N').asstring
    else if str = 'ne' then result:=fieldbyname('NE').asstring
    else if str = 'w' then result:=fieldbyname('W').asstring
    else if str = 'e' then result:=fieldbyname('E').asstring
    else if str = 'sw' then result:=fieldbyname('SW').asstring
    else if str = 's' then result:=fieldbyname('S').asstring
    else if str = 'se' then result:=fieldbyname('SE').asstring
    else result:=str;
  end;
end;

function TDatawell.FilterProfanity(str: string): string;
begin
  result:=str;
  if not Datawell.TableGlobals.fieldbyname('L12').asboolean then exit;
  str:=Datawell.subs2('cunt','c***',str);
  str:=Datawell.subs2('fuck','f***',str);
  str:=Datawell.subs2('shit','s***',str);
  str:=Datawell.subs2('piss','p***',str);
  str:=Datawell.subs2('cock','c***',str);
  str:=Datawell.subs2('dick','d***',str);
  str:=Datawell.subs2('twat','t***',str);
  str:=Datawell.subs2('pussy','p****',str);
  str:=Datawell.subs2('whore','w****',str);
  str:=Datawell.subs2('slut','s***',str);
  str:=Datawell.subs2('asshole','a******',str);
  str:=Datawell.subs2('jackass','j******',str);
  str:=Datawell.subs2('bitch','b****',str);
  str:=Datawell.subs2('bastard','b******',str);
  str:=Datawell.subs2('fag','f**',str);
  str:=Datawell.subs2('tits','t***',str);
  str:=Datawell.subs2('nigger','n*****',str);
  result:=str;
end;

function TDatawell.Subs2(oldstr, newstr, str: string): string;
var
  i: integer;
  ostr: string;
begin
  result:=str;
  ostr:=str;
  str:=lowercase(str);
  if oldstr = newstr then exit;
  if pos(oldstr,newstr) > 0 then exit;
  i:=pos(oldstr,str);
  if i < 1 then exit;
  while i > 0 do begin
    insert(newstr,str,i);
    insert(newstr,ostr,i); //cap
    inc(i,length(newstr));
    delete(str,i,length(oldstr));
    delete(ostr,i,length(oldstr)); //cap
    i:=pos(oldstr,str);
  end;
  result:=ostr;
end;

end.
