unit LoginScreen;

interface

uses
  Wizard, HostPort, SingleProfile, fcText, Skins, BackupReminder,
  Database, Main, License, FPassword, PlayerProfiles,
  WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, DBTables, DB, Mask, Wwtable, SysUtils, wwdblook, Dialogs,
  ExtCtrls, WSocket, Menus, Grids, Wwdbigrd, Wwdbgrid, Wwdatsrc, FileCtrl,
  fcLabel, fcButton, fcImgBtn, fcShapeBtn, fcImage, fcImageForm, ImgList,
  jpeg, GIFImage;

type
    TFormLoginScreen = class(TForm)
    MainMenu: TMainMenu;
    Main2: TMenuItem;
    MenuHelp: TMenuItem;
    DSProfiles: TwwDataSource;
    GridProfiles: TwwDBGrid;
    BtnQuickConnect: TfcImageBtn;
    BtnExit: TfcImageBtn;
    BtnOnline: TfcImageBtn;
    BtnOffline: TfcImageBtn;
    BtnWizard: TfcImageBtn;
    BtnProfiles: TfcImageBtn;
    BtnHelp: TfcImageBtn;
    BtnHelp2: TfcImageBtn;
    BtnClearPasswords: TfcImageBtn;
    LoginScreen: TfcImageForm;
    TimerSuicide: TTimer;
    BtnSocket: TfcImageBtn;
    BtnLicense: TfcImageBtn;
    PopupMenu1: TPopupMenu;
    PopupRefreshSkin: TMenuItem;
    PopupMenu2: TPopupMenu;
    RefreshSkin1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    ProfileWizard1: TMenuItem;
    LoginOnline1: TMenuItem;
    LoginOffline1: TMenuItem;
    QuickConnect1: TMenuItem;
    PortalHelp1: TMenuItem;
    GamingHelp1: TMenuItem;
    ClearPasswords1: TMenuItem;
    ExitPortal1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    ViewSoftwareLicense1: TMenuItem;
    LoadSkin1: TMenuItem;
    LoadPortalSkin1: TMenuItem;
    Skins1: TMenuItem;
    ClearPortalSkin1: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    ClearPortalSkin2: TMenuItem;
    N8: TMenuItem;
    MenuToggleConnection: TMenuItem;
    MenuToggleConnection2: TMenuItem;
    N9: TMenuItem;
    TimerReconnect: TTimer;
    Esc1: TMenuItem;
    procedure BtnExitClick(Sender: TObject);
    procedure BtnOnlineClick(Sender: TObject);
    procedure BtnLicenseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnHelpClick(Sender: TObject);
    procedure BtnProfilesClick(Sender: TObject);
    procedure BtnWizardClick(Sender: TObject);
    procedure BtnClearPasswordsClick(Sender: TObject);
    procedure BtnQuickConnectClick(Sender: TObject);
    procedure GridProfilesKeyPress(Sender: TObject; var Key: Char);
    procedure GridProfilesDblClick(Sender: TObject);
    procedure BtnQuickConnectMouseEnter(Sender: TObject);
    procedure TimerSuicideTimer(Sender: TObject);
    procedure GridProfilesCalcCellColors(Sender: TObject; Field: TField;
      State: TGridDrawState; Highlight: Boolean; AFont: TFont;
      ABrush: TBrush);
    procedure PopupRefreshSkinClick(Sender: TObject);
    procedure LoadSkin1Click(Sender: TObject);
    procedure ClearPortalSkin1Click(Sender: TObject);
    procedure MenuToggleConnectionClick(Sender: TObject);
    procedure TimerReconnectTimer(Sender: TObject);
    procedure Esc1Click(Sender: TObject);
  private
    { Private declarations }
    procedure ClearChats;
    procedure LoadSkin;
    procedure SetButton(but: TfcImageBtn; data, skindir: string);
    function FigureColor(data: string): integer;
    function ExtractLine(str: string; sl: TStringList): string;
    function GrabElement(element, str: string): string;
  public
    { Public declarations }
  end;

var
  FormLoginScreen: TFormLoginScreen;

implementation

{$R *.DFM}

uses Login;

procedure TFormLoginScreen.FormCreate(Sender: TObject);
begin
  height:=306;
  width:=616;
  BtnSocket.top:=120;
  BtnSocket.left:=193;
  BtnClearPasswords.enabled:=(Datawell.bufferpassword <> '');
end;

procedure TFormLoginScreen.BtnExitClick(Sender: TObject);
begin
  if Datawell.datachecking then exit;
  FormMain.loginclose:=true;
  FormMain.close;
end;

procedure TFormLoginScreen.BtnLicenseClick(Sender: TObject);
var form: TFormLicense;
begin
  form:=TFormLicense.create(self);
  form.MemoLicense.lines.assign(FormLogin.MemoLicense.lines);
  form.showmodal;
  form.free;
end;

procedure TFormLoginScreen.BtnHelpClick(Sender: TObject);
begin
  if not visible then exit;
  case TComponent(sender).tag of
    7: Datawell.Help('login_screen');
    8: Datawell.Help('mudding_basics');
  end;
end;

procedure TFormLoginScreen.GridProfilesKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then begin
    key:=#0;
    BtnOnline.click;
  end;
end;

procedure TFormLoginScreen.GridProfilesDblClick(Sender: TObject);
begin
  BtnOnline.click;
end;

procedure TFormLoginScreen.FormShow(Sender: TObject);
var
  didfind, disablereminder: boolean;
  tempfile: string;
  form: TFormBackupReminder;
begin
//Load the HP images
  FormMain.LoadHPImages;
//Try to load the skin
  LoadSkin;
//Go to the lastest used profile
  didfind:=false;
  GridProfiles.hide;
  with Datawell.TableProfiles do begin
    first;
    while not EOF do begin
      if fieldbyname('Master').asinteger = Datawell.TableGlobals.fieldbyname('S3').asinteger then begin
        didfind:=true;
        break;
      end;
      next;
    end;
    if not didfind then first;
  end;
  GridProfiles.show;
  GridProfiles.setfocus;
//Check login
  with Datawell.TableGlobals do begin
    edit;
    fieldbyname('I6').asinteger:=fieldbyname('I6').asinteger+1;
    post;
    if not fieldbyname('L10').asboolean then begin
      if fieldbyname('I6').asinteger > 300 then begin
        form:=TFormBackupReminder.create(self);
        form.showmodal;
        disablereminder:=form.disablereminder;
        form.free;
        edit;
        fieldbyname('I6').asinteger:=0;
        if disablereminder then fieldbyname('L10').asboolean:=true;
        post;
      end;
    end;
  end;
  if (Datawell.TableGlobals.FieldByName('L11').asboolean) and (Datawell.disconnected) then
    TimerReconnect.enabled:=true;
end;

procedure TFormLoginScreen.BtnClearPasswordsClick(Sender: TObject);
begin
  Datawell.password:='';
  Datawell.bufferpassword:='';
  BtnClearPasswords.enabled:=false;
end;

procedure TFormLoginScreen.BtnProfilesClick(Sender: TObject);
var
  form: TFormProfiles;
  master: integer;
  sel: TStringList;
begin
  sel:=TStringList.create;
  sel.assign(GridProfiles.selected);
  form:=TFormProfiles.create(self);
  GridProfiles.hide;
  form.showmodal;
  GridProfiles.selected.assign(sel);
  GridProfiles.applyselected;
  with Datawell.TableProfiles do begin
    master:=fieldbyname('Master').asinteger;
    if master > 0 then begin
      first;
      while not EOF do begin
        if fieldbyname('Master').asinteger = master then break;
        next;
      end;
    end;
    refresh;
  end;
  GridProfiles.show;
  form.free;
  Datawell.TableProfiles.refresh;
  GridProfiles.refresh;
  if Datawell.password = '' then BtnClearPasswords.enabled:=false;
  refresh;
end;

procedure TFormLoginScreen.BtnQuickConnectClick(Sender: TObject);
var
  form: TFormProfile;
  didfind: boolean;
  master: integer;
  table: TwwTable;
begin
//Check to see if there's a quick connect profile
  master:=Datawell.TableProfiles.fieldbyname('Master').asinteger;
  didfind:=false;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=Datawell.bde;
    tablename:='Profiles.db';
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      if (fieldbyname('Player').asstring = 'Quick') and
        (fieldbyname('Mud').asstring = 'Connect') then begin
        didfind:=true;
        break;
      end;
      next;
    end;
    if not didfind then begin
      first;
      while not EOF do begin
        if fieldbyname('Master').asinteger = master then break;
        next;
      end;
    end;
  end;
  table.free;
  if not didfind then begin
    if messagedlg('Quick Connect profile does not exist.  Create it now?',
      mtinformation,[mbyes,mbcancel],0) = mrcancel then exit;
    form:=TFormProfile.create(self);
    form.NewPlayer('Quick','Connect','','','','','elcome','',false,1,nil);
    form.free;
  end;
  BtnOnline.click;
end;

procedure TFormLoginScreen.BtnOnlineClick(Sender: TObject);
var
  emess: string;
  i: integer;
  online, quickie: boolean;
  form: TFormFPassword;
  form2: TFormHostPort;
begin
//Check if there
  if Datawell.TableProfiles.fieldbyname('Master').asinteger < 1 then begin
    messagedlg('You must create a profile first',mtinformation,[mbok],0);
    BtnProfiles.setfocus;
    exit;
  end;
//Check if it's a quick-connect, and if it's online
  quickie:=(Datawell.TableProfiles.fieldbyname('Player').asstring = 'Quick') and
    (Datawell.TableProfiles.fieldbyname('Mud').asstring = 'Connect');
  online:=(TBitBtn(sender).tag = 2);
//If it's a quick-connect, and it's online, ask for the connection data
  if (quickie) and (online) then begin
    form2:=TFormHostPort.create(self);
    form2.EditHost.text:=Datawell.TableProfiles.fieldbyname('Host').asstring;
    form2.EditPort.text:=Datawell.TableProfiles.fieldbyname('Port').asstring;
    form2.CheckCR.checked:=Datawell.TableProfiles.fieldbyname('CR').asboolean;
    form2.EditTrigger.text:=Datawell.TableProfiles.fieldbyname('Trigger').asstring;
    form2.showmodal;
    if form2.linked then begin
      //Save the connection data
      with Datawell.TableProfiles do begin
        edit;
        fieldbyname('Host').asstring:=form2.EditHost.text;
        fieldbyname('Port').asstring:=form2.EditPort.text;
        fieldbyname('Trigger').asstring:=form2.EditTrigger.text;
        fieldbyname('CR').asboolean:=form2.CheckCR.checked;
        post;
      end;
      form2.free;
    end
    else begin
      form2.free;
      exit;
    end;
  end;
//Update the connection data if it's changed from the previous one
  with Datawell.TableProfiles do begin
    if Datawell.masterindex <> inttostr(fieldbyname('Master').asinteger) then begin
      Datawell.masterindex:=inttostr(fieldbyname('Master').asinteger);
      Datawell.masterinteger:=fieldbyname('Master').asinteger;
      Datawell.password:='';
      Datawell.bufferpassword:='';
      BtnClearPasswords.enabled:=false;
      ClearChats;
    end;
    if (Datawell.bufferpassword <> '') and (fieldbyname('Password').asstring <> '') then begin
      Datawell.bufferpassword:='';
      BtnClearPasswords.enabled:=false;
    end;
    if Datawell.password = '' then Datawell.password:=Datawell.bufferpassword;
    if Datawell.password = '' then Datawell.password:=fieldbyname('Password').asstring;
    if Datawell.player <> fieldbyname('Player').asstring then
      Datawell.player:=fieldbyname('Player').asstring;
    if Datawell.password2 <> fieldbyname('Password2').asstring then
      Datawell.password2:=fieldbyname('Password2').asstring;
    if Datawell.mud <> fieldbyname('Mud').asstring then
      Datawell.mud:=fieldbyname('Mud').asstring;
    if FormMain.Telnet.host <> fieldbyname('Host').asstring then
      FormMain.Telnet.host:=fieldbyname('Host').asstring;
    if FormMain.Telnet.port <> fieldbyname('Port').asstring then
      FormMain.Telnet.port:=fieldbyname('Port').asstring;
    if FormMain.MUDAnsi.jumpstartstring <> fieldbyname('Trigger').asstring then
      FormMain.MUDAnsi.jumpstartstring:=fieldbyname('Trigger').asstring;
    if fieldbyname('CR').asboolean then Datawell.cr:=#13 else Datawell.cr:=#13+#10;
    Datawell.script.clear;
    Datawell.script.assign(fieldbyname('Script'));
  end;
//Alter the data as necessary
  if quickie then Begin
    Datawell.player:='Quick Connect';
    Datawell.mud:='';
  end;
  if Datawell.mud = '' then Datawell.mud:=FormMain.Telnet.host+':'+FormMain.Telnet.port;
  if FormMain.MUDAnsi.jumpstartstring = '' then FormMain.MUDAnsi.jumpstartstring:='xxx';
  FormMain.MUDAnsi.EnableJumpstart:=false;
//Other data
  Datawell.DataFailed:=false;
  Datawell.GotData:=false;
  Datawell.ringed:=false;
  Datawell.tablessetup:=false;
//Check host and port
  if FormMain.Telnet.host = '' then begin
    messagedlg('The profile does not have a valid host',mtinformation,[mbok],0);
    BtnProfiles.setfocus;
    exit;
  end;
  if FormMain.Telnet.port = '' then begin
    messagedlg('The profile does not have a valid port',mtinformation,[mbok],0);
    BtnProfiles.setfocus;
    exit;
  end;
//Ask for password if not saved
  if (online) and (Datawell.password = '') and (not quickie) then begin
    form:=TFormFPassword.create(self);
    form.LabelTitle.caption:='Please enter your password';
    if not Datawell.TableGlobals.fieldbyname('L5').asboolean then form.BigScreen;
    form.showmodal;
    if form.CheckInfo.checked then begin
      Datawell.TableGlobals.edit;
      Datawell.TableGlobals.fieldbyname('L5').asboolean:=true;
      Datawell.TableGlobals.post;
    end;
    Datawell.password:=form.password;
    form.free;
    if Datawell.password = '' then exit;
    Datawell.bufferpassword:=Datawell.password;
    BtnClearPasswords.enabled:=true;
  end;
//Record the last used profile
  Datawell.TableGlobals.edit;
  Datawell.TableGlobals.fieldbyname('S3').asstring:=Datawell.masterindex;
  Datawell.TableGlobals.post;
//If online, attempt primary connection
  if online then begin
    FormMain.MUDAnsi.increment:=0;
    if Datawell.connected then FormMain.Telnet.close;
    refresh;
    FormMain.DisableForms;
    BtnSocket.show;
    BtnSocket.refresh;
    refresh;
    Datawell.workingoffline:=false;
    try FormMain.Telnet.Connect;
      except on E:ESocketException do begin
        emess:=E.message;
        if pos('annot convert',emess) > 0 then
          emess:='No socket available.  Host is unavailable or your connection is bad'
        else if pos('oute to',emess) > 0 then
          emess:='No route to host.  Please check your connection to the internet';
        messagedlg(emess,mterror,[mbok],0);
        FormMain.EnableForms;
        BtnSocket.hide;
        Datawell.workingoffline:=true;
        abort;
      end;
    end;
    BtnSocket.hide;
    FormMain.MUDAnsi.EnableJumpstart:=(FormMain.MUDAnsi.jumpstartstring <> 'xxx');
    FormMain.caption:=Datawell.mud+' - '+Datawell.player;
    application.title:='Portal - '+Datawell.mud;
    application.hint:='Portal - '+Datawell.mud;
  end
  else begin
    FormMain.caption:=Datawell.mud+' - '+Datawell.player+' (offline)';
    application.hint:='Portal';
    application.hint:='Portal';
  end;
  FormMain.Initialize;
  Datawell.SetupTables(Datawell.masterindex);
  FormMain.EnableForms;
  FormMain.LoadOptions;
  FormMain.online:=online;
  Datawell.workingoffline:=not online;
  FormMain.show;
  FormMain.EditSend.setfocus;
  if online then begin
    for i:=0 to Datawell.Script.count-1 do FormMain.SendData(Datawell.script[i],999);
  end;
  hide;
  TimerSuicide.enabled:=true;
end;

procedure TFormLoginScreen.BtnWizardClick(Sender: TObject);
var form: TFormWizard;
begin
  form:=TFormWizard.create(self);
  form.showmodal;
  form.free;
  Datawell.TableProfiles.refresh;
  GridProfiles.refresh;
end;

procedure TFormLoginScreen.BtnQuickConnectMouseEnter(Sender: TObject);
var h: integer;
begin
  if TFCImageBtn(sender).textoptions.style <> fclsOutline then exit;
  h:=TFCImageBtn(sender).textoptions.outlinecolor;
  TFCImageBtn(sender).textoptions.outlinecolor:=TFCImageBtn(sender).font.color;
  TFCImageBtn(sender).font.color:=h;
end;

procedure TFormLoginScreen.TimerSuicideTimer(Sender: TObject);
begin
  TimerSuicide.enabled:=false;
  FormLogin.LoginScreen(0,false);
end;

procedure TFormLoginScreen.GridProfilesCalcCellColors(Sender: TObject;
  Field: TField; State: TGridDrawState; Highlight: Boolean; AFont: TFont;
  ABrush: TBrush);
begin
  if highlight then begin
    afont.color:=GridProfiles.color;
    abrush.color:=GridProfiles.font.color;
  end
  else begin
    afont.color:=GridProfiles.font.color;
    abrush.color:=GridProfiles.color;
  end
end;

procedure TFormLoginScreen.ClearChats;
begin
  //Clear tellhist/chat tables
  with Datawell do begin
    TableTell.first; while not TableTell.EOF do TableTell.delete;
    TableTellhist.first; while not TableTellhist.EOF do TableTellhist.delete;
    TableChat.first; while not TableChat.EOF do TableChat.delete;
    TableChathist.first; while not TableChathist.EOF do TableChathist.delete;
  end;
end;

procedure TFormLoginScreen.PopupRefreshSkinClick(Sender: TObject);
begin
  FormLogin.LoginScreen(0,BtnSocket.visible);
  FormLogin.TimerClearSkin.enabled:=true;
end;

function TFormLoginScreen.FigureColor(data: string): integer;
begin
  result:=0;
  data:=lowercase(data);
  if copy(data,1,2) = 'cl' then delete(data,1,2);
  if data = 'black' then result:=clblack
  else if data = 'maroon' then result:=clmaroon
  else if data = 'green' then result:=clgreen
  else if data = 'olive' then result:=clolive
  else if data = 'navy' then result:=clnavy
  else if data = 'purple' then result:=clpurple
  else if data = 'teal' then result:=clteal
  else if data = 'silver' then result:=clsilver
  else if data = 'gray' then result:=clgray
  else if data = 'red' then result:=clred
  else if data = 'lime' then result:=cllime
  else if data = 'yellow' then result:=clyellow
  else if data = 'blue' then result:=clblue
  else if data = 'fuchsia' then result:=clfuchsia
  else if data = 'aqua' then result:=claqua
  else if data = 'white' then result:=clwhite
  else begin
    try result:=strtoint(data); except on EConvertError do result:=clblack; end;
  end;
end;

procedure TFormLoginScreen.LoadSkin1Click(Sender: TObject);
var
  form: TFormSkins;
  doload: boolean;
begin
  form:=TFormSkins.create(self);
  form.showmodal;
  doload:=form.doload;
  form.free;
  if not doload then exit;
  FormLogin.LoginScreen(0,BtnSocket.visible);
  FormLogin.TimerClearSkin.enabled:=true;
end;

procedure TFormLoginScreen.ClearPortalSkin1Click(Sender: TObject);
begin
  Datawell.TableGlobals.edit;
  Datawell.TableGlobals.fieldbyname('S23').asstring:='';
  Datawell.TableGlobals.post;
  TimerSuicide.enabled:=true;
  FormLogin.TimerClearSkin.enabled:=true;
end;

function TFormLoginScreen.ExtractLine(str: string; sl: TStringList): string;
var i: integer;
begin
  result:='';
  for i:=0 to sl.count-1 do begin
    if lowercase(copy(sl[i],1,length(str))) = lowercase(str) then begin
      result:=sl[i];
      break;
    end;
  end;
  if result = '' then exit;
  i:=pos(':',result);
  if i < 1 then begin
    result:='';
    exit;
  end;
  delete(result,1,i);
  result:=Datawell.cutleadingspaces(result);
  result:=Datawell.cuttrailingspaces(result);
end;

procedure TFormLoginScreen.LoadSkin;
var
  p, x, y: integer;
  work, skindir, bmp, grid, ptitle, mtitle, pw, mw, conn, imagefile: string;
  lines: TStringList;
  isbold, isitalic, iscentered, failed: boolean;
begin
  failed:=false;
  lines:=TStringList.create;
  skindir:=Datawell.TableGlobals.fieldbyname('S23').asstring;
  if skindir = '' then exit;
  skindir:=Datawell.exedir+'\skins\'+skindir;
  if not fileexists(skindir+'\config.txt') then begin
    messagedlg('Skin file: '+skindir+'\config.txt does not exist',mtinformation,[mbok],0);
    Datawell.TableGlobals.edit;
    Datawell.TableGlobals.fieldbyname('S23').asstring:='';
    Datawell.TableGlobals.post;
    exit;
  end;
  try lines.loadfromfile(skindir+'\config.txt'); except on EFOpenError do failed:=true; end;
  if lines.count < 1 then begin
    messagedlg('Skin file: '+skindir+'\config.txt is invalid',mtinformation,[mbok],0);
    Datawell.TableGlobals.edit;
    Datawell.TableGlobals.fieldbyname('S23').asstring:='';
    Datawell.TableGlobals.post;
    lines.free;
    exit;
  end;
  if ExtractLine('exit',lines) = '' then begin
    messagedlg('Skin is missing exit button configuration',mtinformation,[mbok],0);
    Datawell.TableGlobals.edit;
    Datawell.TableGlobals.fieldbyname('S23').asstring:='';
    Datawell.TableGlobals.post;
    lines.free;
    exit;
  end;
  grid:=ExtractLine('grid',lines);
  if grid = '' then begin
    messagedlg('Skin is missing profiles grid configuration',mtinformation,[mbok],0);
    Datawell.TableGlobals.edit;
    Datawell.TableGlobals.fieldbyname('S23').asstring:='';
    Datawell.TableGlobals.post;
    lines.free;
    exit;
  end;
  conn:=ExtractLine('connection',lines);
  //Setup background
  bmp:=ExtractLine('background',lines);
  if bmp = '' then begin
    messagedlg('Skin is missing background configuration',mtinformation,[mbok],0);
    Datawell.TableGlobals.edit;
    Datawell.TableGlobals.fieldbyname('S23').asstring:='';
    Datawell.TableGlobals.post;
    lines.free;
    exit;
  end;
  work:=GrabElement('tcolor',bmp);
  bmp:=GrabElement('file',bmp);
  if work <> '' then LoginScreen.transparentcolor:=FigureColor(work)
  else LoginScreen.transparentcolor:=clnone;
  BtnLicense.hide;
  BtnProfiles.hide;
  BtnWizard.hide;
  BtnOnline.hide;
  BtnQuickConnect.hide;
  BtnOffline.hide;
  BtnHelp.hide;
  BtnHelp2.hide;
  BtnClearPasswords.hide;
  BtnExit.hide;
  GridProfiles.hide;
  bmp:=skindir+'\'+bmp;
  bmp:=Datawell.subs('/','\',bmp);
  if not fileexists(bmp) then bmp:=bmp+'.bmp';
  if fileexists(bmp) then begin
    try LoginScreen.picture.bitmap.loadfromfile(bmp); except on EFOpenError do failed:=true; end;
  end;
  x:=left+(width div 2);
  y:=top+(height div 2);
  height:=LoginScreen.picture.bitmap.height;
  width:=LoginScreen.picture.bitmap.width;
  LoginScreen.applybitmapregion;
  //Setup buttons
  SetButton(BtnLicense,ExtractLine('license',lines),skindir);
  SetButton(BtnProfiles,ExtractLine('profiles',lines),skindir);
  SetButton(BtnWizard,ExtractLine('wizard',lines),skindir);
  SetButton(BtnOnline,ExtractLine('online',lines),skindir);
  SetButton(BtnQuickConnect,ExtractLine('quick',lines),skindir);
  SetButton(BtnOffline,ExtractLine('offline',lines),skindir);
  SetButton(BtnHelp,ExtractLine('help',lines),skindir);
  SetButton(BtnHelp2,ExtractLine('gaming',lines),skindir);
  SetButton(BtnClearPasswords,ExtractLine('passwords',lines),skindir);
  SetButton(BtnExit,ExtractLine('exit',lines),skindir);
  lines.free;
  //Setup grid
  GridProfiles.left:=Datawell.toint(GrabElement('left',grid));
  GridProfiles.top:=Datawell.toint(GrabElement('top',grid));
  GridProfiles.height:=Datawell.toint(GrabElement('height',grid));
  GridProfiles.width:=Datawell.toint(GrabElement('width',grid));
  GridProfiles.titlecolor:=FigureColor(GrabElement('color',grid));
  GridProfiles.color:=FigureColor(GrabElement('wcolor',grid));
  GridProfiles.font.name:=GrabElement('font',grid);
  GridProfiles.font.size:=Datawell.toint(GrabElement('fsize',grid));
  GridProfiles.font.color:=FigureColor(GrabElement('fcolor',grid));
  isbold:=(copy(Datawell.cutallspaces(lowercase(GrabElement('fbold',grid))),1,1) = 't');
  isitalic:=(copy(Datawell.cutallspaces(lowercase(GrabElement('fitalic',grid))),1,1) = 't');
  if (isbold) and (isitalic) then GridProfiles.font.style:=[fsbold,fsitalic]
  else if isbold then GridProfiles.font.style:=[fsbold]
  else if isitalic then GridProfiles.font.style:=[fsitalic]
  else GridProfiles.font.style:=[];
  GridProfiles.titlefont.name:=GrabElement('tfont',grid);
  GridProfiles.titlefont.size:=Datawell.toint(GrabElement('tsize',grid));
  GridProfiles.titlefont.color:=FigureColor(GrabElement('tcolor',grid));
  isbold:=(copy(Datawell.cutallspaces(lowercase(GrabElement('tbold',grid))),1,1) = 't');
  isitalic:=(copy(Datawell.cutallspaces(lowercase(GrabElement('titalic',grid))),1,1) = 't');
  if (isbold) and (isitalic) then GridProfiles.titlefont.style:=[fsbold,fsitalic]
  else if isbold then GridProfiles.titlefont.style:=[fsbold]
  else if isitalic then GridProfiles.titlefont.style:=[fsitalic]
  else GridProfiles.titlefont.style:=[];
  ptitle:=GrabElement('ptitle',grid);
  mtitle:=GrabElement('mtitle',grid);
  pw:=inttostr(Datawell.toint(GrabElement('pwidth',grid)));
  mw:=inttostr(Datawell.toint(GrabElement('mwidth',grid)));
  with GridProfiles do begin
    selected.clear;
    selected.add('Player' + #9 + pw + #9 + ptitle);
    selected.add('Mud' + #9 + mw + #9 + mtitle);
    applyselected;
    show;
  end;
  //Setup connection panel
  if conn <> '' then begin
    BtnSocket.left:=Datawell.toint(GrabElement('left',conn));
    BtnSocket.top:=Datawell.toint(GrabElement('top',conn));
    iscentered:=(copy(Datawell.cutallspaces(lowercase(GrabElement('centered',conn))),1,1) = 't');
    imagefile:=GrabElement('file',conn);
    BtnSocket.transparentcolor:=FigureColor(GrabElement('tcolor',conn));
    BtnSocket.caption:=GrabElement('caption',conn);
    BtnSocket.font.name:=GrabElement('font',conn);
    BtnSocket.font.size:=Datawell.toint(GrabElement('fsize',conn));
    BtnSocket.textoptions.disabledcolors.highlightcolor:=FigureColor(GrabElement('fcolor',conn));
    isbold:=(copy(Datawell.cutallspaces(lowercase(GrabElement('fbold',conn))),1,1) = 't');
    isitalic:=(copy(Datawell.cutallspaces(lowercase(GrabElement('fitalic',conn))),1,1) = 't');
    if (isbold) and (isitalic) then BtnSocket.font.style:=[fsbold,fsitalic]
    else if isbold then BtnSocket.font.style:=[fsbold]
    else if isitalic then BtnSocket.font.style:=[fsitalic]
    else BtnSocket.font.style:=[];
    BtnSocket.offsets.textX:=Datawell.toint(GrabElement('fxoffset',conn));
    BtnSocket.offsets.textY:=Datawell.toint(GrabElement('fyoffset',conn));
    BtnSocket.textoptions.disabledcolors.shadecolor:=FigureColor(GrabElement('focolor',conn));
    imagefile:=skindir+'\'+imagefile;
    imagefile:=Datawell.subs('/','\',imagefile);
    if not fileexists(imagefile) then imagefile:=imagefile+'.bmp';
    if fileexists(imagefile) then begin
      failed:=false;
      try BtnSocket.image.loadfromfile(imagefile); except on EFOpenError do failed:=true; end;
    end;
    BtnSocket.width:=BtnSocket.image.width;
    BtnSocket.height:=BtnSocket.image.height;
    if iscentered then begin
      BtnSocket.top:=(height div 2)-(BtnSocket.height div 2);
      BtnSocket.left:=(width div 2)-(BtnSocket.width div 2);
    end;
  end;
  //Center the new screen
  left:=x-(width div 2);
  top:=y-(width div 2);
end;

procedure TFormLoginScreen.SetButton(but: TfcImageBtn; data, skindir: string);
var
  imagefile, work: string;
  isbold, isitalic, failed: boolean;
begin
  if data = '' then begin
    but.visible:=false;
    exit;
  end;
  but.visible:=true;
  but.left:=Datawell.toint(GrabElement('left',data));
  but.top:=Datawell.toint(GrabElement('top',data));
  imagefile:=GrabElement('file',data);
  but.transparentcolor:=FigureColor(GrabElement('tcolor',data));
  but.caption:=GrabElement('caption',data);
  but.font.name:=GrabElement('font',data);
  but.font.size:=Datawell.toint(GrabElement('fsize',data));
  but.font.color:=FigureColor(GrabElement('fcolor',data));
  isbold:=(copy(Datawell.cutallspaces(lowercase(GrabElement('fbold',data))),1,1) = 't');
  isitalic:=(copy(Datawell.cutallspaces(lowercase(GrabElement('fitalic',data))),1,1) = 't');
  if (isbold) and (isitalic) then but.font.style:=[fsbold,fsitalic]
  else if isbold then but.font.style:=[fsbold]
  else if isitalic then but.font.style:=[fsitalic]
  else but.font.style:=[];
  but.offsets.textX:=Datawell.toint(GrabElement('fxoffset',data));
  but.textoptions.style:=fclsDefault;
  but.offsets.textY:=Datawell.toint(GrabElement('fyoffset',data));
  work:=GrabElement('focolor',data);
  if work <> '' then begin
    but.textoptions.style:=fclsOutline;
    but.textoptions.outlinecolor:=FigureColor(work);
  end;
  imagefile:=skindir+'\'+imagefile;
  imagefile:=Datawell.subs('/','\',imagefile);
  if not fileexists(imagefile) then imagefile:=imagefile+'.bmp';
  if not fileexists(imagefile) then exit;
  failed:=false;
  try but.image.loadfromfile(imagefile); except on EFOpenError do failed:=true; end;
  but.width:=but.image.width;
  but.height:=but.image.height;
end;

function TFormLoginScreen.GrabElement(element, str: string): string;
var
  i: integer;
  ostr: string;
begin
  result:='';
  str:=' '+str+' ';
  ostr:=str;
  str:=lowercase(str);
  element:=element;
  i:=pos(' '+element+'=',str);
  if i < 1 then exit;
  delete(ostr,1,i+length(element)+1);
  if copy(ostr,1,1) = '"' then begin
    delete(ostr,1,1);
    i:=pos('"',ostr);
  end
  else i:=pos(' ',ostr);
  result:=copy(ostr,1,i-1);
  if copy(result,length(result),1) = '"' then delete(result,length(result),1);
end;

procedure TFormLoginScreen.MenuToggleConnectionClick(
  Sender: TObject);
begin
  MenuToggleConnection.checked:=not MenuToggleConnection.checked;
  MenuToggleConnection2.checked:=MenuToggleConnection.checked;
  BtnSocket.visible:=MenuToggleConnection.checked;
end;

procedure TFormLoginScreen.TimerReconnectTimer(Sender: TObject);
begin
  if not TimerReconnect.enabled then exit;
  TimerReconnect.enabled:=false;
  if not enabled then exit;
  if not visible then exit;
  BtnOnline.click;
  Datawell.disconnected:=false;
end;

procedure TFormLoginScreen.Esc1Click(Sender: TObject);
begin
  TimerReconnect.enabled:=false;
end;

end.







