unit MapDelete;

interface

uses
  Database,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, WwTable, ExtCtrls, Menus;

type
  TFormMapDelete = class(TForm)
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    ListMaps: TListBox;
    Label2: TLabel;
    Label1: TLabel;
    BtnAll: TBitBtn;
    Label3: TLabel;
    Bevel1: TBevel;
    Panel1: TPanel;
    RBDelete: TRadioButton;
    RBClear: TRadioButton;
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnAllClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    diddelete: boolean;
  end;

var
  FormMapDelete: TFormMapDelete;


implementation

{$R *.DFM}

procedure TFormMapDelete.FormCreate(Sender: TObject);
begin
  diddelete:=false;
end;

procedure TFormMapDelete.BtnCancelClick(Sender: TObject);
begin
  close;
end;

procedure TFormMapDelete.BtnAllClick(Sender: TObject);
var i: integer;
begin
  for i:=0 to ListMaps.items.count-1 do ListMaps.selected[i]:=true;
end;

procedure TFormMapDelete.BtnOKClick(Sender: TObject);
var
  selected: TStringList;
  i: integer;
  table: TwwTable;
  didfind: boolean;
begin
  selected:=TStringList.create;
  for i:=0 to ListMaps.items.count-1 do begin
    if ListMaps.selected[i] then selected.add(ListMaps.items[i]);
  end;
  if selected.count < 1 then begin
    messagedlg('No map levels are selected',mtinformation,[mbok],0);
    exit;
  end;
  diddelete:=true;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=Datawell.bde;
    for i:=0 to selected.count-1 do begin
      active:=false;
      tablename:='Maps.db';
      wwfilter.clear;
      filterActivate;
      active:=true;
      first;
      didfind:=false;
      while not EOF do begin
        if fieldbyname('Map').asstring = selected[i] then begin
          didfind:=true;
          break;
        end;
        next;
      end;
      if didfind then begin
        //Delete Map
        if RBDelete.checked then delete;
        //Delete Rooms
        active:=false;
        tablename:='Rooms.db';
        wwfilter.clear;
        wwfilter.add('(Map = "'+selected[i]+'")');
        filterActivate;
        active:=true;
        first;
        while not EOF do delete;
        //Delete Room Memos
        active:=false;
        tablename:='RoomMemos.db';
        wwfilter.clear;
        wwfilter.add('(Map = "'+selected[i]+'")');
        filterActivate;
        active:=true;
        first;
        while not EOF do delete;
        //Delete Exits
        active:=false;
        tablename:='Exits.db';
        wwfilter.clear;
        wwfilter.add('(Map = "'+selected[i]+'")');
        filterActivate;
        active:=true;
        first;
        while not EOF do delete;
      end;
    end;
  end;
  table.free;
  selected.free;
  close;
end;

end.
