unit Menu;

interface

uses
  Database,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, Wwdbigrd, Wwdbgrid, ExtCtrls, Db, Wwdatsrc, Printers,
  Menus, DBTables, Wwtable;

type
  TFormMenu = class(TForm)
    Label53: TLabel;
    Label54: TLabel;
    Bevel13: TBevel;
    GridMenu: TwwDBGrid;
    EditItem: TEdit;
    EditHotkey: TComboBox;
    BtnAddHotkey: TBitBtn;
    BtnClearHotkey: TBitBtn;
    BtnPrint: TBitBtn;
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    DSMenu: TwwDataSource;
    DialogPrint: TPrintDialog;
    PanelStatus: TPanel;
    Bevel1: TBevel;
    Status: TLabel;
    BtnClear: TBitBtn;
    LabelWarn: TLabel;
    LabelWarn2: TLabel;
    BtnHelp: TBitBtn;
    MainMenu1: TMainMenu;
    Main1: TMenuItem;
    MenuHelp: TMenuItem;
    procedure BtnAddHotkeyClick(Sender: TObject);
    procedure BtnClearHotkeyClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure DSMenuDataChange(Sender: TObject; Field: TField);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BtnPrintClick(Sender: TObject);
    procedure BtnClearClick(Sender: TObject);
    procedure BtnHelpClick(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateDropdown;
    procedure AddHotkey(str: string);
    procedure AppendHotkey(x: integer; i, hk: string);
    procedure CheckHotkeys;
  public
    { Public declarations }
  end;

var
  FormMenu: TFormMenu;

implementation

{$R *.DFM}

procedure TFormMenu.FormCreate(Sender: TObject);
begin
  with Datawell.TableMenuTemp do begin
    first;
    while not EOF do delete;
  end;
  with Datawell.TableMenu do begin
    first;
    while not EOF do begin
      Datawell.TableMenuTemp.append;
      Datawell.TableMenuTemp.fieldbyname('Index').asinteger:=fieldbyname('Index').asinteger;
      Datawell.TableMenuTemp.fieldbyname('Item').asstring:=fieldbyname('Item').asstring;
      Datawell.TableMenuTemp.fieldbyname('Hotkey').asstring:=fieldbyname('Hotkey').asstring;
      Datawell.TableMenuTemp.post;
      next;
    end;
  end;
  CheckHotkeys;
  UpdateDropdown;
  Datawell.TableMenuTemp.first;
end;

procedure TFormMenu.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Status.caption:=' '+(sender as TControl).hint;
end;

procedure TFormMenu.BtnOKClick(Sender: TObject);
begin
  with Datawell.TableMenu do begin
    first;
    while not EOF do delete;
  end;
  GridMenu.hide;
  with Datawell.TableMenuTemp do begin
    first;
    while not EOF do begin
      Datawell.TableMenu.append;
      Datawell.TableMenu.fieldbyname('Master').asinteger:=Datawell.masterinteger;
      Datawell.TableMenu.fieldbyname('Index').asinteger:=fieldbyname('Index').asinteger;
      Datawell.TableMenu.fieldbyname('Item').asstring:=fieldbyname('Item').asstring;
      Datawell.TableMenu.fieldbyname('Hotkey').asstring:=fieldbyname('Hotkey').asstring;
      Datawell.TableMenu.post;
      next;
    end;
  end;
  close;
end;

procedure TFormMenu.BtnCancelClick(Sender: TObject);
begin
  close;
end;

procedure TFormMenu.DSMenuDataChange(Sender: TObject; Field: TField);
begin
  EditItem.text:=Datawell.TableMenuTemp.fieldbyname('Item').asstring;
end;

procedure TFormMenu.BtnAddHotkeyClick(Sender: TObject);
begin
  Datawell.TableMenuTemp.edit;
  Datawell.TableMenuTemp.fieldbyname('Hotkey').asstring:=EditHotkey.text;
  Datawell.TableMenuTemp.post;
  UpdateDropDown;
  GridMenu.setfocus;
  LabelWarn.show;
  LabelWarn2.show;
end;

procedure TFormMenu.BtnClearHotkeyClick(Sender: TObject);
begin
  Datawell.TableMenuTemp.edit;
  Datawell.TableMenuTemp.fieldbyname('Hotkey').asstring:='';
  Datawell.TableMenuTemp.post;
  UpdateDropDown;
  GridMenu.setfocus;
  LabelWarn.show;
  LabelWarn2.show;
end;

procedure TFormMenu.AddHotkey(str: string);
var
  doadd: boolean;
  table: TwwTable;
begin
  doadd:=true;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=Datawell.bde;
    tablename:='MenuTemp.db';
    active:=true;
    first;
    while not EOF do begin
      if str = fieldbyname('Hotkey').asstring then begin
        doadd:=false;
        break;
      end;
      next;
    end;
  end;
  table.free;
  if not doadd then exit;
  EditHotkey.items.add(str);
end;

procedure TFormMenu.UpdateDropdown;
begin
  EditHotkey.items.clear;
  AddHotkey('Ctrl+A');
  AddHotkey('Ctrl+B');
  AddHotkey('Ctrl+C');
  AddHotkey('Ctrl+D');
  AddHotkey('Ctrl+E');
  AddHotkey('Ctrl+F');
  AddHotkey('Ctrl+G');
  AddHotkey('Ctrl+H');
  AddHotkey('Ctrl+I');
  AddHotkey('Ctrl+J');
  AddHotkey('Ctrl+K');
  AddHotkey('Ctrl+L');
  AddHotkey('Ctrl+M');
  AddHotkey('Ctrl+N');
  AddHotkey('Ctrl+O');
  AddHotkey('Ctrl+P');
  AddHotkey('Ctrl+Q');
  AddHotkey('Ctrl+R');
  AddHotkey('Ctrl+S');
  AddHotkey('Ctrl+T');
  AddHotkey('Ctrl+U');
  AddHotkey('Ctrl+V');
  AddHotkey('Ctrl+W');
  AddHotkey('Ctrl+X');
  AddHotkey('Ctrl+Y');
  AddHotkey('Ctrl+Z');
  AddHotkey('Shift+Ctrl+A');
  AddHotkey('Shift+Ctrl+B');
  AddHotkey('Shift+Ctrl+C');
  AddHotkey('Shift+Ctrl+D');
  AddHotkey('Shift+Ctrl+E');
  AddHotkey('Shift+Ctrl+F');
  AddHotkey('Shift+Ctrl+G');
  AddHotkey('Shift+Ctrl+H');
  AddHotkey('Shift+Ctrl+I');
  AddHotkey('Shift+Ctrl+J');
  AddHotkey('Shift+Ctrl+K');
  AddHotkey('Shift+Ctrl+L');
  AddHotkey('Shift+Ctrl+M');
  AddHotkey('Shift+Ctrl+N');
  AddHotkey('Shift+Ctrl+O');
  AddHotkey('Shift+Ctrl+P');
  AddHotkey('Shift+Ctrl+Q');
  AddHotkey('Shift+Ctrl+R');
  AddHotkey('Shift+Ctrl+S');
  AddHotkey('Shift+Ctrl+T');
  AddHotkey('Shift+Ctrl+U');
  AddHotkey('Shift+Ctrl+V');
  AddHotkey('Shift+Ctrl+W');
  AddHotkey('Shift+Ctrl+X');
  AddHotkey('Shift+Ctrl+Y');
  AddHotkey('Shift+Ctrl+Z');
  AddHotkey('Ctrl+Del');
  AddHotkey('Ctrl+Ins');
  AddHotkey('Shift+Del');
  AddHotkey('Shift+Ins');
  AddHotkey('Shift+Esc');
  AddHotkey('Ctrl+Enter');
  AddHotkey('Shift+Ctrl+Enter');
end;

procedure TFormMenu.BtnPrintClick(Sender: TObject);
var
  work: string;
  PF: System.text;
  table: TwwTable;
begin
  if not DialogPrint.execute then exit;
  AssignPRN(PF);
  ReWrite(PF);
  Printer.title:=Datawell.ptitle;
  Printer.canvas.font.name:='Arial';
  Printer.canvas.font.size:=14;
  Printer.canvas.font.style:=[fsbold];
  writeln(PF,'');
  Printer.canvas.font.style:=[fsbold,fsunderline];
  writeln(PF,'Portal Menu Hotkeys ('+Datawell.player+' - '+Datawell.mud+')');
  Printer.canvas.font.name:='Courier New';
  Printer.canvas.font.style:=[fsbold];
  Printer.canvas.font.size:=10;
  writeln(PF,'');
  table:=TwwTable.create(self);
  with table do begin
    databasename:=Datawell.bde;
    tablename:='MenuTemp.db';
    active:=true;
    first;
    while not EOF do begin
      if fieldbyname('Hotkey').asstring <> '' then begin
        fmtstr(work,' %-16s - %-60s',
          [fieldbyname('Hotkey').asstring,fieldbyname('Item').asstring]);
        writeln(PF,work);
      end;
      next;
    end;
  end;
  table.free;
  CloseFile(PF);
  GridMenu.setfocus;
end;

procedure TFormMenu.AppendHotkey(x: integer; i, hk: string);
begin
  with Datawell.TableMenuTemp do begin
    EditKey;
    fieldbyname('Index').asinteger:=x;
    if GotoKey then exit;
    append;
    fieldbyname('Index').asinteger:=x;
    fieldbyname('Item').asstring:=i;
    fieldbyname('Hotkey').asstring:=hk;
    post;
  end;  
end;

procedure TFormMenu.BtnClearClick(Sender: TObject);
begin
//Main: UpdateMenu
//Menu: CheckHotkeys
  GridMenu.hide;
  with Datawell.TableMenuTemp do begin
    first;
    while not EOF do delete;
  end;
  CheckHotkeys;
  Datawell.TableMenuTemp.refresh;
  Datawell.TableMenuTemp.first;
  GridMenu.show;
  UpdateDropdown;
  if visible then GridMenu.setfocus;
  LabelWarn.show;
  LabelWarn2.show;
end;

procedure TFormMenu.BtnHelpClick(Sender: TObject);
begin
  Datawell.Help('menu_items');
end;

procedure TFormMenu.CheckHotkeys;
begin
  AppendHotkey(1010,'Panic Button','Shift+Esc');
  AppendHotkey(1020,'Jumpstart Portal','Ctrl+J');
  AppendHotkey(1030,'Lock Character','');
  AppendHotkey(1040,'Clear Keyhistory','');
  AppendHotkey(1050,'Graph Paper Generator','');
  AppendHotkey(1060,'Replace Contents of Autotyper with Download','Ctrl+W');
  AppendHotkey(1070,'Paste Download into Autotyper at Cursor','');
  AppendHotkey(1080,'Capture Download to File','');
  AppendHotkey(1090,'Clear Download','');
  AppendHotkey(1100,'Upload Files','Ctrl+L');
  AppendHotkey(1110,'Disconnect from Sever','Shift+Ctrl+X');
  AppendHotkey(1120,'Reconnect','');
  AppendHotkey(1130,'Attempt Secondary Connection','');
  AppendHotkey(1140,'Disconnect Secondary Connection','');
  AppendHotkey(1150,'Reverse Connection Control','');
  AppendHotkey(1155,'Import/Export','');
  AppendHotkey(1160,'Exit Program','');
  AppendHotkey(2010,'Copy Selected Text to Clipboard','Ctrl+C');
  AppendHotkey(2020,'Copy Selected Text to Autotyper','Ctrl+Y');
  AppendHotkey(2030,'Send Text from Clipboard','Shift+Ins');
  AppendHotkey(2040,'Send Space-Delimited Text from Clipboard','');
  AppendHotkey(2050,'Paste Space-Delimited Text from Clipboard to Command Line','');
  AppendHotkey(2060,'Cut Selected Text from Command Line to Clipboard','Shift+Del');
  AppendHotkey(2070,'Copy Selected Text to Clipboard','Ctrl+Ins');
  AppendHotkey(2080,'Paste Text from Clipboard into Command Line','Ctrl+V');
  AppendHotkey(2090,'Insert Line-Break into Command Line','Shift+Ctrl+Enter');
  AppendHotkey(2100,'Insert Esc Character into Command Line','');
  AppendHotkey(2110,'Insert Beep into Command Line','');
  AppendHotkey(2120,'Send Masked Text','Ctrl+K');
  AppendHotkey(2130,'Send Text File','');
  AppendHotkey(3010,'Find Text','Ctrl+F');
  AppendHotkey(3020,'Find Next Text Occurence','Ctrl+G');
  AppendHotkey(3030,'Clear Scrollback Buffer','');
  AppendHotkey(3040,'Capture Scrollback Buffer to File','');
  AppendHotkey(3050,'Log Incoming Text to File','');
  AppendHotkey(4010,'Aliases','Ctrl+A');
  AppendHotkey(4020,'Macros','Ctrl+M');
  AppendHotkey(4030,'Quickchars','Ctrl+H');
  AppendHotkey(4040,'Nicknames','Ctrl+N');
  AppendHotkey(4050,'Ticker','Ctrl+T');
  AppendHotkey(4060,'Next Buffered Command','');
  AppendHotkey(4070,'Clear Command Buffer','');
  AppendHotkey(4080,'Recording On/Off','Ctrl+R');
  AppendHotkey(5010,'Events','Ctrl+E');
  AppendHotkey(5020,'Quick Event','Ctrl+Q');
  AppendHotkey(5040,'Variable Maintenance','');
  AppendHotkey(5050,'Setup Groups','Ctrl+P');
  AppendHotkey(5060,'Activate the BASE Group','Ctrl+B');
  AppendHotkey(6010,'Open Autotyper','Ctrl+Enter');
  AppendHotkey(6020,'Autotype Text from Autotyper','Ctrl+U');
  AppendHotkey(6030,'Autoscribble','Ctrl+I');
  AppendHotkey(7010,'Program Options','Ctrl+O');
  AppendHotkey(7020,'Show Toolbar','');
  AppendHotkey(7030,'Show Record Tool on Toolbar','');
  AppendHotkey(7040,'Show Statusbar','');
  AppendHotkey(7050,'Show HP1 Bar','');
  AppendHotkey(7060,'Show HP2 Bar','');
  AppendHotkey(7070,'Show HP3 Bar','');
  AppendHotkey(7080,'Show HP4 Bar','');
  AppendHotkey(7090,'HP Bar Setup Assistant','');
  AppendHotkey(7100,'Customize Toolbar','');
  AppendHotkey(7110,'Customize Menu Hotkeys','');
  AppendHotkey(7120,'Reduce Font Size','');
  AppendHotkey(7130,'Increase Font Size','');
  AppendHotkey(7140,'Choose Display Font','');
  AppendHotkey(7150,'Setup Display Colors','');
  AppendHotkey(8010,'Canvas','Shift+Ctrl+N');
  AppendHotkey(8020,'Imagery','Shift+Ctrl+I');
  AppendHotkey(8030,'Chat Monitor','Shift+Ctrl+C');
  AppendHotkey(8040,'Tell Monitor','Shift+Ctrl+T');
  AppendHotkey(8050,'Cartographer','Shift+Ctrl+G');
  AppendHotkey(8070,'View System Messages','Shift+Ctrl+M');
  AppendHotkey(8080,'Clear System Messages','');
  AppendHotkey(8090,'Close All Screens','');
  AppendHotkey(9010,'Build Playlist','');
  AppendHotkey(9020,'Load Playlist','');
  AppendHotkey(9030,'Play Song','');
  AppendHotkey(9040,'Pause Song','');
  AppendHotkey(9050,'Rewind Song to Beginning','');
  AppendHotkey(9060,'Goto Previous Song','');
  AppendHotkey(9070,'Goto Next Song','');
  AppendHotkey(9080,'Goto First Song','');
  AppendHotkey(9090,'Goto Last Song','');
  AppendHotkey(9100,'Repeat Song','');
  AppendHotkey(9110,'Randomize Playlist','');
end;

end.
