program Portal;

uses
  Forms,
  Windows,
  SysUtils,
  Main in 'Main.pas' {FormMain},
  Tellhist in 'TELLHIST.PAS' {FormTellhist},
  Events in 'Events.pas' {FormEvents},
  Macros in 'MACROS.PAS' {FormMacros},
  Options in 'Options.pas' {FormOptions},
  Actions in 'Actions.pas' {FormActions},
  About in 'About.pas' {FormAbout},
  Alias in 'Alias.pas' {FormAlias},
  Editor in 'Editor.pas' {FormEditor},
  Secure in 'Secure.pas' {FormSecure},
  License in 'License.pas' {FormLicense},
  Mapper in 'Mapper.pas' {FormMapper},
  Clock in 'Clock.pas' {FormClock},
  Color in 'Color.pas' {FormColor},
  Password in 'Password.pas' {FormPassword},
  Database in 'Database.pas' {Datawell: TDataModule},
  Image in 'Image.pas' {FormImagery},
  Nicknames in 'Nicknames.pas' {FormNicknames},
  Filtered in 'Filtered.pas' {FormFiltered},
  Toolbar in 'Toolbar.pas' {FormToolbar},
  Disconnect in 'Disconnect.pas' {FormDisconnect},
  FPassword in 'FPassword.pas' {FormFPassword},
  Groups in 'Groups.pas' {FormGroups},
  Chat in 'Chat.pas' {FormChat},
  Colors in 'Colors.pas' {FormColors},
  Ticker in 'Ticker.pas' {FormTicker},
  VarSelect in 'VarSelect.pas' {FormVarSelect},
  Vars in 'Vars.pas' {FormVars},
  Sounds in 'Sounds.pas' {FormSounds},
  Importing in 'Importing.pas' {FormImporting},
  Tools in 'Tools.pas' {FormTools},
  Map in 'Map.pas' {FormMap},
  RProperties in 'RProperties.pas' {FormRProperties},
  NewMap in 'NewMap.pas' {FormNewMap},
  MapProperties in 'MapProperties.pas' {FormMapProperties},
  Wizard in 'Wizard.pas' {FormWizard},
  EnterRegister in 'EnterRegister.pas' {FormEnterRegister},
  ConfirmLink in 'ConfirmLink.pas' {FormConfirmLink},
  RoomExit in 'RoomExit.pas' {FormRoomExit},
  SetCoordinates in 'SetCoordinates.pas' {FormSetCoordinates},
  CharterFailure in 'CharterFailure.pas' {FormCharterFailure},
  EnterText in 'EnterText.pas' {FormEnterText},
  WarnMove in 'WarnMove.pas' {FormWarnMove},
  NewConnection in 'NewConnection.pas' {FormNewConnection},
  RenameExit in 'RenameExit.pas' {FormRenameExit},
  EventQ in 'EventQ.pas' {FormEventQ},
  MapName in 'MapName.pas' {FormMapName},
  AskRegister in 'AskRegister.pas' {FormAskRegister},
  Functions in 'Functions.pas' {FormFunctions},
  HP in 'HP.pas' {FormHP},
  EnemySetup in 'EnemySetup.pas' {FormEnemySetup},
  Canvas in 'Canvas.pas' {FormCanvas},
  CProperties in 'CProperties.pas' {FormCProperties},
  RenameCanvas in 'RenameCanvas.pas' {FormRenameCanvas},
  Music in 'Music.pas' {FormMusic},
  AM in 'AM.pas' {FormAM},
  HostPort in 'HostPort.pas' {FormHostPort},
  Menu in 'Menu.pas' {FormMenu},
  PlayerProfiles in 'PlayerProfiles.pas' {FormProfiles},
  SingleProfile in 'SingleProfile.pas' {FormProfile},
  Login in 'Login.pas' {FormLogin2},
  LoginScreen in 'LoginScreen.pas' {FormLoginScreen},
  Saving in 'Saving.pas' {FormSaving},
  VarGrabber in 'VarGrabber.pas' {FormVarGrab},
  CreateNewEvent in 'CreateNewEvent.pas' {FormNewEvent},
  IO in 'IO.pas' {FormIO},
  Skins in 'Skins.pas' {FormSkins},
  PrinterDPI in 'PrinterDPI.pas' {FormPrinterDPI},
  BackupReminder in 'BackupReminder.pas' {FormBackupReminder},
  Room in 'Room.pas' {FormRoomMonitor},
  MapDelete in 'MapDelete.pas' {FormMapDelete},
  Note in 'Note.pas' {FormNote},
  SelectGroup in 'SelectGroup.pas' {FormSelectGroup},
  Session in 'Session.pas' {FormSession};

{$R *.RES}

const
  AllowedInstances = 1;

var
  MyAppName   : Array[0..255] of Char;
  MyClassName : Array[0..255] of Char;
  NumFound    : Integer;
  LastFound   : HWnd;
  MyPopup     : HWnd;
  AllowMult   : boolean;

function LookAtAllWindows(Handle: HWND; Temp: LongInt): BOOL; stdcall;
var
  WindowName : Array[0..255] of Char;
  ClassName  : Array[0..255] of Char;
begin
  // Go get the windows class name
  if GetClassName(Handle,ClassName,SizeOf(ClassName)) > 0 then begin
    // Is the window class the same?
    if StrComp(ClassName,MyClassName) = 0 then begin
      // Get its window caption
      if GetWindowText(Handle,WindowName,SizeOf(WindowName)) > 0 then begin
        // Does this have the same window title?
        if (pos('Portal',WindowName) > 0) or
          (pos('PClock',WindowName) > 0) or
          (pos('PLock',WindowName) > 0) then begin
          inc(NumFound);
          // Are the handles different?
          if Handle <> Application.Handle then LastFound:=Handle;
        end;
      end;
    end;
  end;
end;

begin
  NumFound:=0; LastFound:=0;
  // First, determine what this application's name is
  GetWindowText(Application.Handle,MyAppName,SizeOf(MyAppName));
  // Now determine the class name for this application
  GetClassName(Application.Handle,MyClassName,SizeOf(MyClassName));
  // Now count how many others out there are Delphi apps with this title
  EnumWindows(@LookAtAllWindows,0);
//  if NumFound > AllowedInstances then begin
  AllowMult:=fileexists(extractfiledir(application.exename)+'\allowmultiple.co');
  if (NumFound > AllowedInstances) and (not AllowMult) then begin
    // There is another instance running, bring it to the front!
    MyPopup := GetLastActivePopup(LastFound);
    // Bring it to the top in the ZOrder
    BringWindowToTop(LastFound);
    // Is the window iconized?
    if IsIconic(MyPopup) then
      // Restore it to its original position
      ShowWindow(MyPopup,SW_RESTORE)
    else
      // Bring it to the front
      SetForegroundWindow(MyPopup);
  end
  else begin
    // None running - allow this instance to continue
    Application.Title := 'Portal GT';
  Application.hint:='Portal@';
    Application.showhint:=true;
    Application.CreateForm(TFormLogin, FormLogin);
  Application.CreateForm(TDatawell, Datawell);
  Application.CreateForm(TFormMain, FormMain);
  Application.CreateForm(TFormMap, FormMap);
  Application.Run;
  end
end.
