unit RenameExit;

interface

uses
  Database,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Wwtable;

type
  TFormRenameExit = class(TForm)
    Label1: TLabel;
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    EditExit: TEdit;
    procedure EditExitChange(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditExitKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
    ex, map, x, y: string;
  end;

var
  FormRenameExit: TFormRenameExit;

implementation

{$R *.DFM}

procedure TFormRenameExit.FormCreate(Sender: TObject);
begin
  ex:='';
end;

procedure TFormRenameExit.EditExitChange(Sender: TObject);
begin
  if length(EditExit.text) > 0 then BtnOK.enabled:=true
  else BtnOK.enabled:=false;
end;

procedure TFormRenameExit.BtnCancelClick(Sender: TObject);
begin
  ex:='';
  close;
end;

procedure TFormRenameExit.EditExitKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #13 then begin
    BtnOK.click;
    key:=#0;
  end;
end;

procedure TFormRenameExit.BtnOKClick(Sender: TObject);
var
  didfind: boolean;
  work: string;
  table: TwwTable;
begin
  if EditExit.text = '' then begin
    messagedlg('You must enter an exit',mtinformation,[mbok],0);
    EditExit.setfocus;
    exit;
  end;
  if EditExit.text = ex then begin
    messagedlg('That''s the same exit',mtinformation,[mbok],0);
    EditExit.selectall;
    EditExit.setfocus;
    exit;
  end;
  didfind:=false;
  table:=TwwTable.create(self);
  with table do begin
    databasename:=Datawell.bde;
    tablename:='Exits.db';
    wwfilter.clear;
    wwfilter.add('(Map = "'+map+'")');
    wwfilter.add('(X = '+x+')');
    wwfilter.add('(Y = '+y+')');
    filterActivate;
    active:=true;
    first;
    while not EOF do begin
      if fieldbyname('Exit').asstring = EditExit.text then begin
        didfind:=true;
        break;
      end;
      next;
    end;
  end;
  table.free;
  ex:=EditExit.text;
  close;
end;

end.
