unit SelectGroup;

interface

uses
  Database,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ColorGrd, Mask, Wwdbedit, Wwdbspin, wwdblook,
  Wwdotdot, Wwdbcomb, WwTable, Groups;

type
  TFormSelectGroup = class(TForm)
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    Panel1: TPanel;
    EditGroup: TwwDBComboBox;
    Label1: TLabel;
    BtnGroups: TSpeedButton;
    procedure BtnCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure BtnGroupsClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    oldgroup, group: string;
  end;

var
  FormSelectGroup: TFormSelectGroup;

implementation

{$R *.DFM}

procedure TFormSelectGroup.FormCreate(Sender: TObject);
begin
  group:='';
end;

procedure TFormSelectGroup.BtnCancelClick(Sender: TObject);
begin
  close;
end;

procedure TFormSelectGroup.BtnOKClick(Sender: TObject);
var
  cmds: TStringList;
  didfind: boolean;
begin
  didfind:=false;
  if EditGroup.text = '' then begin
    messagedlg('You must select a group',mtinformation,[mbok],0);
    EditGroup.setfocus;
    exit;
  end;
  group:=EditGroup.text;
  close;
end;

procedure TFormSelectGroup.BtnGroupsClick(Sender: TObject);
var form: TFormGroups;
begin
  form:=TFormGroups.create(self);
  form.frommain:=false;
  form.showmodal;
  form.free;
  FormShow(nil);
end;

procedure TFormSelectGroup.FormShow(Sender: TObject);
var table: TwwTable;
begin
  table:=TwwTable.create(self);
  with table do begin
    databasename:=Datawell.bde;
    tablename:='Groups.db';
    wwfilter.assign(Datawell.TableGroups.wwfilter);
    active:=true;
    first;
    EditGroup.items.clear;
    while not EOF do begin
      if fieldbyname('Group').asstring <> oldgroup then begin
        EditGroup.items.add(fieldbyname('Group').asstring);
      end;
      next;
    end;
  end;
end;

end.

