unit SingleProfile;

interface

uses
  Database,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Mask, ExtCtrls, Gauges, Db, DBTables, Wwtable, fcLabel,
  Menus;

type
  TFormProfile = class(TForm)
    DialogOpen: TOpenDialog;
    TimerImport: TTimer;          
    PanelStatus: TPanel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Gauge: TGauge;
    LabelStatus: TfcLabel;
    BtnOK: TBitBtn;
    PanelMain: TPanel;
    Label6: TLabel;
    Label8: TLabel;
    Label4: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label7: TLabel;
    Bevel1: TBevel;
    Label5: TLabel;
    Label1: TLabel;
    EditPassword: TMaskEdit;
    EditPlayer: TEdit;
    EditMud: TEdit;
    BtnMud: TBitBtn;
    MemoScript: TMemo;
    EditMUDHost: TEdit;
    EditMUDPort: TEdit;
    CheckCR: TCheckBox;
    EditTrigger: TEdit;
    BtnNew: TBitBtn;
    BtnImport: TBitBtn;
    BtnCancel: TBitBtn;
    EditMUDWebsite: TEdit;
    BtnMUDWebsite: TBitBtn;
    BtnSave: TBitBtn;
    PanelStatusBase: TPanel;
    Status: TLabel;
    BtnHelp: TBitBtn;
    MainMenu: TMainMenu;
    MenuHelp: TMenuItem;
    EditPassword2: TMaskEdit;
    Label9: TLabel;
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BtnCancelClick(Sender: TObject);
    procedure EditMUDWebsiteChange(Sender: TObject);
    procedure BtnMUDWebsiteClick(Sender: TObject);
    procedure EditPlayerKeyPress(Sender: TObject; var Key: Char);
    procedure BtnSaveClick(Sender: TObject);
    procedure TimerImportTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure BtnHelpClick(Sender: TObject);
  private
    { Private declarations }
    function StartImport: boolean;
    procedure DoImport;
    procedure AddGauge;
    procedure ResetMacros(master: integer; populated: boolean);
    function IsClean(str: string): boolean;
    procedure ClearTable(table: TwwTable);
  public
    { Public declarations }
    wizard, wizpassed: boolean;
    procedure NewPlayer(player, mud, password, password2, host, port, trigger, website: string;
      usecr: boolean; mas: integer; script: TStrings);
  end;

var
  FormProfile: TFormProfile;
  importfile: string;
  masterglobal, fileversion: integer;
  overwriting: boolean;

implementation

{$R *.DFM}

procedure TFormProfile.FormCreate(Sender: TObject);
begin
  wizard:=false;
  wizpassed:=false;
  overwriting:=false;
  importfile:='';
  masterglobal:=0;
  fileversion:=0;
  PanelStatus.left:=79;
  PanelStatus.top:=93;
end;

procedure TFormProfile.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Status.caption:=' '+(sender as TControl).hint;
end;

procedure TFormProfile.ResetMacros(master: integer; populated: boolean);
var
  macros, commands, orders, temp: TStringList;
  i: integer;
begin
  macros:=TStringList.create;
  commands:=TStringList.create;
  orders:=TStringList.create;
  macros.add('F2'); commands.add(''); orders.add('aa');
  macros.add('F3'); commands.add(''); orders.add('ab');
  macros.add('F4'); commands.add(''); orders.add('ac');
  macros.add('F5'); commands.add(''); orders.add('ad');
  macros.add('F6'); commands.add(''); orders.add('ae');
  macros.add('F7'); commands.add(''); orders.add('af');
  macros.add('F8'); commands.add(''); orders.add('ag');
  macros.add('F9'); commands.add(''); orders.add('ah');
  macros.add('F10'); commands.add(''); orders.add('ai');
  macros.add('F11'); commands.add(''); orders.add('aj');
  macros.add('F12'); commands.add(''); orders.add('ak');
  macros.add('Alt+F1'); commands.add(''); orders.add('ca');
  macros.add('Alt+F2'); commands.add(''); orders.add('cb');
  macros.add('Alt+F3'); commands.add(''); orders.add('cc');
  macros.add('Alt+F4'); commands.add(''); orders.add('cd');
  macros.add('Alt+F5'); commands.add(''); orders.add('ce');
  macros.add('Alt+F6'); commands.add(''); orders.add('cf');
  macros.add('Alt+F7'); commands.add(''); orders.add('cg');
  macros.add('Alt+F8'); commands.add(''); orders.add('ch');
  macros.add('Alt+F9'); commands.add(''); orders.add('ci');
  macros.add('Alt+F10'); commands.add(''); orders.add('cj');
  macros.add('Alt+F11'); commands.add(''); orders.add('ck');
  macros.add('Alt+F12'); commands.add(''); orders.add('cl');
  macros.add('Shift+F1'); commands.add(''); orders.add('ea');
  macros.add('Shift+F2'); commands.add(''); orders.add('eb');
  macros.add('Shift+F3'); commands.add(''); orders.add('ec');
  macros.add('Shift+F4'); commands.add(''); orders.add('ed');
  macros.add('Shift+F5'); commands.add(''); orders.add('ee');
  macros.add('Shift+F6'); commands.add(''); orders.add('ef');
  macros.add('Shift+F7'); commands.add(''); orders.add('eg');
  macros.add('Shift+F8'); commands.add(''); orders.add('eh');
  macros.add('Shift+F9'); commands.add(''); orders.add('ei');
  macros.add('Shift+F10'); commands.add(''); orders.add('ej');
  macros.add('Shift+F11'); commands.add(''); orders.add('ek');
  macros.add('Shift+F12'); commands.add(''); orders.add('el');
  macros.add('Ctrl+F1'); commands.add(''); orders.add('ga');
  macros.add('Ctrl+F2'); commands.add(''); orders.add('gb');
  macros.add('Ctrl+F3'); commands.add(''); orders.add('gc');
  macros.add('Ctrl+F4'); commands.add(''); orders.add('gd');
  macros.add('Ctrl+F5'); commands.add(''); orders.add('ge');
  macros.add('Ctrl+F6'); commands.add(''); orders.add('gf');
  macros.add('Ctrl+F7'); commands.add(''); orders.add('gg');
  macros.add('Ctrl+F8'); commands.add(''); orders.add('gh');
  macros.add('Ctrl+F9'); commands.add(''); orders.add('gi');
  macros.add('Ctrl+F10'); commands.add(''); orders.add('gj');
  macros.add('Ctrl+F11'); commands.add(''); orders.add('gk');
  macros.add('Ctrl+F12'); commands.add(''); orders.add('gl');
  macros.add('Numpad1'); orders.add('ia');
  macros.add('Numpad2'); orders.add('ib');
  macros.add('Numpad3'); orders.add('ic');
  macros.add('Numpad4'); orders.add('id');
  macros.add('Numpad5'); orders.add('ie');
  macros.add('Numpad6'); orders.add('if');
  macros.add('Numpad7'); orders.add('ig');
  macros.add('Numpad8'); orders.add('ih');
  macros.add('Numpad9'); orders.add('ii');
  macros.add('Numpad0'); orders.add('ij');
  macros.add('NumpadD'); orders.add('ik');
  macros.add('Numpad/'); orders.add('il');
  macros.add('Numpad*'); orders.add('im');
  macros.add('Numpad-'); orders.add('in');
  macros.add('Numpad+'); orders.add('io');
  if populated then begin
    commands.add(Datawell.Dir('sw'));
    commands.add(Datawell.Dir('s'));
    commands.add(Datawell.Dir('se'));
    commands.add(Datawell.Dir('w'));
    commands.add(';look;search');
    commands.add(Datawell.Dir('e'));
    commands.add(Datawell.Dir('nw'));
    commands.add(Datawell.Dir('n'));
    commands.add(Datawell.Dir('ne'));
    commands.add(Datawell.Dir('d'));
    commands.add(Datawell.Dir('u'));
  end
  else begin
    commands.add('');
    commands.add('');
    commands.add('');
    commands.add('');
    commands.add('');
    commands.add('');
    commands.add('');
    commands.add('');
    commands.add('');
    commands.add('');
    commands.add('');
  end;
  commands.add('');
  commands.add('');
  commands.add('');
  commands.add('');
  temp:=TStringList.create;
  with Datawell.TableMacros do begin
    for i:=0 to macros.count-1 do begin
      temp.clear;
      if commands[i] <> '' then temp.add(commands[i]);
      append;
      fieldbyname('Master').asinteger:=master;
      fieldbyname('Order').asstring:=orders[i];
      fieldbyname('Macro').asstring:=macros[i];
      fieldbyname('Script').assign(temp);
      post;
    end;
  end;
  temp.free;
  macros.free;
  commands.free;
  orders.free;
end;

procedure TFormProfile.NewPlayer(player, mud, password, password2, host, port, trigger, website: string;
  usecr: boolean; mas: integer; script: TStrings);
var
  chars, acts, retains, reverses, creverses: TStringList;
  master, i: integer;
begin
//Get the next profile integer
  master:=mas;
  if master < 1 then begin
    with Datawell.TableGlobals do begin
      master:=fieldbyname('I3').asinteger+1;
      edit;
      fieldbyname('I3').asinteger:=master;
      post;
    end;
  end;
  chars:=TStringList.create;
  acts:=TStringList.create;
  chars.add('d'); acts.add('d');
  chars.add('e'); acts.add('e');
  chars.add('i'); acts.add('in');
  chars.add('n'); acts.add('n');
  chars.add('o'); acts.add('out');
  chars.add('r'); acts.add('enter');
  chars.add('s'); acts.add('s');
  chars.add('u'); acts.add('u');
  chars.add('w'); acts.add('w');
  chars.add('x'); acts.add('exit');
  chars.add('t'); acts.add(Datawell.Dir('ne'));
  chars.add('v'); acts.add(Datawell.Dir('se'));
  chars.add('z'); acts.add(Datawell.Dir('sw'));
  chars.add('q'); acts.add(Datawell.Dir('nw'));
  retains:=TStringList.create;
  retains.add('n');
  retains.add('e');
  retains.add('s');
  retains.add('w');
  retains.add('ne');
  retains.add('se');
  retains.add('sw');
  retains.add('nw');
  retains.add('u');
  retains.add('d');
  reverses:=TStringList.create;
  creverses:=TStringList.create;
  reverses.add('n');
  creverses.add('s');
  reverses.add('e');
  creverses.add('w');
  reverses.add('s');
  creverses.add('n');
  reverses.add('w');
  creverses.add('e');
  reverses.add('ne');
  creverses.add('sw');
  reverses.add('se');
  creverses.add('nw');
  reverses.add('sw');
  creverses.add('ne');
  reverses.add('nw');
  creverses.add('se');
  reverses.add('u');
  creverses.add('d');
  reverses.add('d');
  creverses.add('u');
  reverses.add('in');
  creverses.add('out');
  reverses.add('out');
  creverses.add('in');
  reverses.add('enter');
  creverses.add('exit');
  reverses.add('exit');
  creverses.add('enter');
//Add the new Profile
  with Datawell.TableProfiles do begin
    append;
    fieldbyname('Master').asinteger:=master;
    fieldbyname('Player').asstring:=player;
    fieldbyname('Password').asstring:=password;
    fieldbyname('Password2').asstring:=password2;
    fieldbyname('MUD').asstring:=mud;
    fieldbyname('Host').asstring:=host;
    fieldbyname('Port').asstring:=port;
    fieldbyname('URL').asstring:=website;
    fieldbyname('Trigger').asstring:=trigger;
    fieldbyname('CR').asboolean:=usecr;
    fieldbyname('Script').assign(script);
    post;
  end;
//Add the BASE Group
  with Datawell.TableGroups do begin
    append;
    fieldbyname('Master').asinteger:=master;
    fieldbyname('Group').asstring:='BASE';
    fieldbyname('FGColor').asinteger:=0;
    fieldbyname('BGColor').asinteger:=16776960;
    post;
  end;
//Add the default Quickchars
  with Datawell.TableActions do begin
    for i:=0 to chars.count-1 do begin
      append;
      fieldbyname('Master').asinteger:=master;
      fieldbyname('Character').asstring:=chars[i];
      fieldbyname('Action').asstring:=acts[i];
      post;
    end;
  end;
//Add the default Macros
  ResetMacros(master,true);
//Add the default retained commands
  with Datawell.TableRetain do begin
    for i:=0 to retains.count-1 do begin
      append;
      fieldbyname('Master').asinteger:=master;
      fieldbyname('Retain').asstring:=retains[i];
      fieldbyname('AddSpace').asboolean:=false;
      fieldbyname('KeepSelected').asboolean:=false;
      post;
    end;
  end;
//Add the default reversed commands
  with Datawell.TableReverse do begin
    for i:=0 to reverses.count-1 do begin
      append;
      fieldbyname('Master').asinteger:=master;
      fieldbyname('Command').asstring:=reverses[i];
      fieldbyname('Reverse').asstring:=creverses[i];
      post;
    end;
  end;
//Program Options
  with Datawell.TableOptions do begin
    append;
  //Master
    fieldbyname('Master').asinteger:=master;
  //Autotyper
    fieldbyname('EditorTop').asinteger:=0;
    fieldbyname('EditorLeft').asinteger:=0;
    fieldbyname('EditorHeight').asinteger:=450;
    fieldbyname('EditorWidth').asinteger:=579;
    fieldbyname('EditorFontName').asstring:='Courier New';
    fieldbyname('EditorFontStyle').asinteger:=0;
    fieldbyname('EditorFontSize').asinteger:=10;
    fieldbyname('EditorFColor').asinteger:=clblack;
    fieldbyname('EditorBColor').asinteger:=clwhite;
    fieldbyname('EditorWrap').asboolean:=true;
    fieldbyname('EditorShowWidthbar').asboolean:=true;
    fieldbyname('EditorStayOnTop').asboolean:=false;
    fieldbyname('EditorClear').asboolean:=false;
    fieldbyname('EditorAsk').asboolean:=false;
    fieldbyname('AutotypeSave').asboolean:=true;
  //Chat Monitor
    fieldbyname('ChatTop').asinteger:=0;
    fieldbyname('ChatLeft').asinteger:=0;
    fieldbyname('ChatHeight').asinteger:=300;
    fieldbyname('ChatWidth').asinteger:=640;
    fieldbyname('ChatStayOnTop').asboolean:=false;
    fieldbyname('ChatExpanded').asboolean:=false;
    fieldbyname('ChatShowing').asboolean:=false;
    fieldbyname('ChatLineHeight').asinteger:=1;
    fieldbyname('ChatShowLineGrid').asboolean:=true;
    fieldbyname('ChatLineGridHeight').asinteger:=66;
  //Tell Monitor
    fieldbyname('TellTop').asinteger:=0;
    fieldbyname('TellLeft').asinteger:=0;
    fieldbyname('TellHeight').asinteger:=181;
    fieldbyname('TellWidth').asinteger:=640;
    fieldbyname('TellStayOnTop').asboolean:=false;
    fieldbyname('TellExpanded').asboolean:=false;
    fieldbyname('TellShowing').asboolean:=false;
  //Status Monitor
    fieldbyname('StatusTop').asinteger:=341;
    fieldbyname('StatusLeft').asinteger:=0;
    fieldbyname('StatusShowing').asboolean:=false;
    fieldbyname('StatusStayOnTop').asboolean:=false;
  //Message Monitor
    fieldbyname('MessagesTop').asinteger:=341;
    fieldbyname('MessagesLeft').asinteger:=242;
    fieldbyname('MessagesWidth').asinteger:=398;
    fieldbyname('MessagesShowing').asboolean:=false;
    fieldbyname('MessagesStayOnTop').asboolean:=false;
  //Imagery
    fieldbyname('ImageryTop').asinteger:=0;
    fieldbyname('ImageryLeft').asinteger:=504;
    fieldbyname('ImageryShowing').asboolean:=false;
    fieldbyname('ImageryHeight').asinteger:=155;
    fieldbyname('ImageryWidth').asinteger:=136;
    fieldbyname('ImageryColor').asinteger:=clteal;
    fieldbyname('ImageryStayOnTop').asboolean:=true;
    fieldbyname('ImageryShowGauge').asboolean:=true;
    fieldbyname('ImageryShowLabel').asboolean:=true;
  //Floating Toolbar
    fieldbyname('FToolbarTop').asinteger:=0;
    fieldbyname('FToolbarLeft').asinteger:=0;
    fieldbyname('FToolbarHeight').asinteger:=200;
    fieldbyname('FToolbarWidth').asinteger:=200;
    fieldbyname('FToolbarVertical').asboolean:=true;
    fieldbyname('FToolbarShowing').asboolean:=false;
    fieldbyname('FToolbarStayOnTop').asboolean:=true;
  //Filtered Text
    fieldbyname('FilteredTop').asinteger:=0;
    fieldbyname('FilteredLeft').asinteger:=0;
    fieldbyname('FilteredHeight').asinteger:=400;
    fieldbyname('FilteredWidth').asinteger:=500;
    fieldbyname('FilteredShowing').asboolean:=false;
    fieldbyname('FilteredStayOnTop').asboolean:=false;
  //Basic Options
    fieldbyname('Group').asstring:='BASE';
    fieldbyname('Top').asinteger:=0;
    fieldbyname('Left').asinteger:=0;
    fieldbyname('Height').asinteger:=480;
    fieldbyname('Width').asinteger:=640;
    fieldbyname('ScrollPosition').asinteger:=250;
    fieldbyname('ShowHP').asboolean:=true;
    fieldbyname('ShowHP2').asboolean:=false;
    fieldbyname('ShowHP3').asboolean:=true;
    fieldbyname('ShowHP4').asboolean:=false;
    fieldbyname('HP3Offset').asinteger:=295;
    fieldbyname('HP4Offset').asinteger:=295;
    fieldbyname('HP3Size').asinteger:=9;
    fieldbyname('HP4Size').asinteger:=9;
    fieldbyname('FontName').asstring:='Courier New';
    fieldbyname('FontSize').asinteger:=10;
    fieldbyname('FontStyle').asinteger:=0;
    fieldbyname('Toolbar').asstring:='a_4bc_defh_g>-_Y_kl_|_s_w';
    fieldbyname('ToolbarShowing').asboolean:=true;
    fieldbyname('HelpbarShowing').asboolean:=true;
    fieldbyname('ColorScreen').asinteger:=clblack;
    fieldbyname('ColorText').asinteger:=clsilver;
    fieldbyname('Color0').asinteger:=clblack;
    fieldbyname('Color1').asinteger:=clmaroon;
    fieldbyname('Color2').asinteger:=clgreen;
    fieldbyname('Color3').asinteger:=clolive;
    fieldbyname('Color4').asinteger:=clnavy;
    fieldbyname('Color5').asinteger:=clpurple;
    fieldbyname('Color6').asinteger:=clteal;
    fieldbyname('Color7').asinteger:=clsilver;
    fieldbyname('Color8').asinteger:=clgray;
    fieldbyname('Color9').asinteger:=clred;
    fieldbyname('Color10').asinteger:=cllime;
    fieldbyname('Color11').asinteger:=clyellow;
    fieldbyname('Color12').asinteger:=clblue;
    fieldbyname('Color13').asinteger:=clfuchsia;
    fieldbyname('Color14').asinteger:=claqua;
    fieldbyname('Color15').asinteger:=clwhite;
  //Messages Tab
    fieldbyname('Scroll').asinteger:=999;
    fieldbyname('History').asinteger:=50;
    fieldbyname('Chars').asinteger:=3;
    fieldbyname('SpecialDuration').asinteger:=5;
    fieldbyname('Color21').asinteger:=claqua;
    fieldbyname('Color22').asinteger:=claqua;
    fieldbyname('Beep').asstring:=Datawell.getsounddir+'beep.wav';
  //Status Bars Tab
    fieldbyname('Cl1').asinteger:=clred;
    fieldbyname('Cl2').asinteger:=clred;
    fieldbyname('Cl3').asinteger:=clred;
    fieldbyname('Cl4').asinteger:=clred;
    fieldbyname('Cl5').asinteger:=clred;
    fieldbyname('HP').asinteger:=25;
    fieldbyname('SP').asinteger:=25;
    fieldbyname('GP1').asinteger:=25;
    fieldbyname('GP2').asinteger:=25;
    fieldbyname('Enemy').asinteger:=25;
    fieldbyname('Cm1').asinteger:=clyellow;
    fieldbyname('Cm2').asinteger:=clyellow;
    fieldbyname('Cm3').asinteger:=clyellow;
    fieldbyname('Cm4').asinteger:=clyellow;
    fieldbyname('Cm5').asinteger:=clyellow;
    fieldbyname('HP2').asinteger:=50;
    fieldbyname('SP2').asinteger:=50;
    fieldbyname('GP12').asinteger:=50;
    fieldbyname('GP22').asinteger:=50;
    fieldbyname('Enemy2').asinteger:=50;
    fieldbyname('Ch1').asinteger:=clgreen;
    fieldbyname('Ch2').asinteger:=clgreen;
    fieldbyname('Ch3').asinteger:=clgreen;
    fieldbyname('Ch4').asinteger:=clgreen;
    fieldbyname('Ch5').asinteger:=clgreen;
    fieldbyname('C1001').asinteger:=cllime;
    fieldbyname('C1002').asinteger:=cllime;
    fieldbyname('C1003').asinteger:=cllime;
    fieldbyname('C1004').asinteger:=cllime;
    fieldbyname('C1005').asinteger:=cllime;
    fieldbyname('Co1').asinteger:=claqua;
    fieldbyname('Co2').asinteger:=claqua;
    fieldbyname('Co3').asinteger:=claqua;
    fieldbyname('Co4').asinteger:=claqua;
    fieldbyname('Co5').asinteger:=claqua;
  //Text Options Tab
    fieldbyname('Typed').asboolean:=true;
    fieldbyname('Autotyper').asboolean:=true;
    fieldbyname('Pasted').asboolean:=true;
    fieldbyname('Aliases').asboolean:=true;
    fieldbyname('Macros').asboolean:=true;
    fieldbyname('Events').asboolean:=true;
    fieldbyname('EQuickchars').asboolean:=true;
    fieldbyname('EScheduler').asboolean:=true;
    fieldbyname('ETicker').asboolean:=true;
    fieldbyname('EParsed').asboolean:=true;
    fieldbyname('FColorTyped').asinteger:=15;
    fieldbyname('BColorTyped').asinteger:=12;
    fieldbyname('NTyped').asboolean:=true;
    fieldbyname('DTyped').asboolean:=false;
    fieldbyname('FColorAutotyper').asinteger:=15;
    fieldbyname('BColorAutotyper').asinteger:=1;
    fieldbyname('NAutotyper').asboolean:=false;
    fieldbyname('DAutotyper').asboolean:=false;
    fieldbyname('FColorAliases').asinteger:=15;
    fieldbyname('BColorAliases').asinteger:=2;
    fieldbyname('NAliases').asboolean:=true;
    fieldbyname('DAliases').asboolean:=false;
    fieldbyname('FColorMacros').asinteger:=15;
    fieldbyname('BColorMacros').asinteger:=3;
    fieldbyname('NMacros').asboolean:=true;
    fieldbyname('DMacros').asboolean:=false;
    fieldbyname('FColorEvents').asinteger:=15;
    fieldbyname('BColorEvents').asinteger:=5;
    fieldbyname('NEvents').asboolean:=true;
    fieldbyname('DEvents').asboolean:=false;
    fieldbyname('FColorPasted').asinteger:=15;
    fieldbyname('BColorPasted').asinteger:=7;
    fieldbyname('NPasted').asboolean:=true;
    fieldbyname('DPasted').asboolean:=false;
    fieldbyname('NQuickchars').asboolean:=true;
    fieldbyname('FColorQuickchars').asinteger:=15;
    fieldbyname('BColorQuickchars').asinteger:=4;
    fieldbyname('DQuickchars').asboolean:=false;
    fieldbyname('NScheduler').asboolean:=true;
    fieldbyname('FColorScheduler').asinteger:=9;
    fieldbyname('BColorScheduler').asinteger:=4;
    fieldbyname('DScheduler').asboolean:=false;
    fieldbyname('NTicker').asboolean:=true;
    fieldbyname('FColorTicker').asinteger:=11;
    fieldbyname('BColorTicker').asinteger:=4;
    fieldbyname('DTicker').asboolean:=false;
    fieldbyname('NParsed').asboolean:=true;
    fieldbyname('FColorParsed').asinteger:=10;
    fieldbyname('BColorParsed').asinteger:=4;
    fieldbyname('DParsed').asboolean:=false;
    fieldbyname('FColorSelected').asinteger:=11;
    fieldbyname('BColorSelected').asinteger:=9;
    fieldbyname('FColorSystem').asinteger:=15;
    fieldbyname('BColorSystem').asinteger:=8;
    fieldbyname('GP1Mask').asstring:='Guild Points 1';
    fieldbyname('GP2Mask').asstring:='Guild Points 2';
  //Miscellaneous Tab
    fieldbyname('Quickchar').asstring:='"';
    fieldbyname('Activator').asstring:=';';
    fieldbyname('LoginMacro').asstring:='';
    fieldbyname('PanicMacro').asstring:='';
    fieldbyname('Sounds').asboolean:=true;
    fieldbyname('EventSounds').asboolean:=true;
    fieldbyname('Autocopy').asboolean:=true;
    fieldbyname('EnableTicker').asboolean:=false;
    fieldbyname('Pageup').asboolean:=true;
    fieldbyname('FeedScrollback').asboolean:=true;
    fieldbyname('ScrollbackLabels').asboolean:=true;
    fieldbyname('ClearSending').asboolean:=true;
    fieldbyname('Escape').asboolean:=false;
    fieldbyname('AltF4ToClose').asboolean:=true;
    fieldbyname('Menu').asboolean:=true;
    fieldbyname('Tab').asboolean:=false;
    fieldbyname('HighlightKeyhistory').asboolean:=true;
  //Command Line Tab
    fieldbyname('RetainAll').asboolean:=false;
    fieldbyname('Retain').asboolean:=false;
  //Reversing Tab
  //FTP Emulation Tab
    fieldbyname('UseLocalDir').asboolean:=false;
    fieldbyname('LocalDir').asstring:=datawell.exedir;
    fieldbyname('OverwriteLocalDir').asboolean:=false;
    post;
  end;
//Program Options2
  with Datawell.TableOptions2 do begin
    append;
    fieldbyname('Master').asinteger:=master;
  //Cartographer
    fieldbyname('MapTop').asinteger:=0;
    fieldbyname('MapLeft').asinteger:=0;
    fieldbyname('MapShowing').asboolean:=false;
    fieldbyname('MapStayOnTop').asboolean:=false;
  //Other Options
    fieldbyname('BTyped').asboolean:=false;
    fieldbyname('BAutotyped').asboolean:=false;
    fieldbyname('BAliases').asboolean:=false;
    fieldbyname('BPasted').asboolean:=false;
    fieldbyname('BMacros').asboolean:=false;
    fieldbyname('BEvents').asboolean:=false;
    fieldbyname('BQuickchars').asboolean:=false;
    fieldbyname('BTicker').asboolean:=false;
    fieldbyname('BParsed').asboolean:=false;
    fieldbyname('Truncate').asboolean:=false;
    fieldbyname('VTyped').asboolean:=false;
    fieldbyname('VAutotyped').asboolean:=false;
    fieldbyname('VAliases').asboolean:=true;
    fieldbyname('VPasted').asboolean:=true;
    fieldbyname('VMacros').asboolean:=true;
    fieldbyname('VEvents').asboolean:=true;
    fieldbyname('VQuickchars').asboolean:=true;
    fieldbyname('VTicker').asboolean:=true;
    fieldbyname('VParsed').asboolean:=true;
    fieldbyname('Groups').asstring:='BASE';
    fieldbyname('AutoShowImagery').asboolean:=true;
    fieldbyname('EnableHyperlinks').asboolean:=true;
    fieldbyname('HyperlinkFGColor').asinteger:=10;
    fieldbyname('HyperlinkBGColor').asinteger:=0;
    fieldbyname('FTyped').asboolean:=false;
    fieldbyname('FAutotyped').asboolean:=false;
    fieldbyname('FAliases').asboolean:=true;
    fieldbyname('FPasted').asboolean:=true;
    fieldbyname('FMacros').asboolean:=true;
    fieldbyname('FEvents').asboolean:=true;
    fieldbyname('FQuickchars').asboolean:=true;
    fieldbyname('FTicker').asboolean:=true;
    fieldbyname('FParsed').asboolean:=true;
    fieldbyname('DisableAliasLED').asboolean:=false;
    fieldbyname('AutoExpand').asboolean:=true;
    fieldbyname('PastedDelay').asinteger:=100;
    fieldbyname('FullFlash').asboolean:=false;
    fieldbyname('HPMask').asstring:='Hit Points';
    fieldbyname('SPMask').asstring:='Spell Points';
    fieldbyname('DelayUpload').asboolean:=true;
    fieldbyname('PCorrect').asboolean:=false;
    fieldbyname('PanicMacro2').asstring:='';
    post;
  end;
//Program Options3
  with Datawell.TableOptions3 do begin
    append;
    fieldbyname('Master').asinteger:=master;
    fieldbyname('S1').asstring:='';
    fieldbyname('S2').asstring:='[36';
    fieldbyname('I1').asinteger:=0;
    fieldbyname('I2').asinteger:=0;
    fieldbyname('I3').asinteger:=480;
    fieldbyname('I4').asinteger:=480;
    fieldbyname('I5').asinteger:=14;
    fieldbyname('I6').asinteger:=0;
    fieldbyname('I12').asinteger:=0;
    fieldbyname('I13').asinteger:=0;
    fieldbyname('I14').asinteger:=300;
    fieldbyname('I15').asinteger:=350;
    fieldbyname('I16').asinteger:=clteal;
    fieldbyname('I17').asinteger:=300;
    fieldbyname('I18').asinteger:=300;
    fieldbyname('I19').asinteger:=clsilver;
    fieldbyname('I20').asinteger:=clblack;
    fieldbyname('I21').asinteger:=clwhite;
    fieldbyname('I22').asinteger:=clblack;
    fieldbyname('I25').asinteger:=10;
    fieldbyname('I26').asinteger:=clgray;
    fieldbyname('I27').asinteger:=clyellow;
    fieldbyname('I28').asinteger:=300;
    fieldbyname('I29').asinteger:=80;
    fieldbyname('L1').asboolean:=false;
    fieldbyname('L2').asboolean:=true;
    fieldbyname('L3').asboolean:=false;
    fieldbyname('L4').asboolean:=false;
    fieldbyname('L5').asboolean:=true;
    fieldbyname('L6').asboolean:=true;
    fieldbyname('L7').asboolean:=true;
    fieldbyname('L8').asboolean:=true;
    fieldbyname('L9').asboolean:=true;
    fieldbyname('L11').asboolean:=false;
    fieldbyname('L12').asboolean:=false;
    fieldbyname('L13').asboolean:=true;
    fieldbyname('L14').asboolean:=false;
    fieldbyname('L15').asboolean:=false;
    fieldbyname('L16').asboolean:=true;
    fieldbyname('L17').asboolean:=false;
    fieldbyname('L19').asboolean:=false;
    fieldbyname('L20').asboolean:=false;
    fieldbyname('L21').asboolean:=true;
    fieldbyname('L22').asboolean:=false;
    fieldbyname('L23').asboolean:=false;
    fieldbyname('L24').asboolean:=true;
    fieldbyname('L25').asboolean:=true;
    fieldbyname('L26').asboolean:=true;
    fieldbyname('L27').asboolean:=true;
    fieldbyname('L28').asboolean:=true;
    fieldbyname('L29').asboolean:=true;
    fieldbyname('L30').asboolean:=true;
    fieldbyname('L31').asboolean:=true;
    fieldbyname('L32').asboolean:=false;
    fieldbyname('L33').asboolean:=true;
    fieldbyname('L34').asboolean:=false;
    fieldbyname('L35').asboolean:=true;
    fieldbyname('L36').asboolean:=true;
    fieldbyname('L37').asboolean:=true;
    fieldbyname('L38').asboolean:=true;
    fieldbyname('L39').asboolean:=true;
    fieldbyname('L40').asboolean:=true;
    fieldbyname('L42').asboolean:=false;
    fieldbyname('L43').asboolean:=false;
    fieldbyname('L44').asboolean:=true;
    fieldbyname('L45').asboolean:=true;
    fieldbyname('L46').asboolean:=false;
    fieldbyname('L47').asboolean:=false;
    fieldbyname('L48').asboolean:=false;
    fieldbyname('L49').asboolean:=true;
    fieldbyname('L50').asboolean:=true;
    fieldbyname('L51').asboolean:=false;
    fieldbyname('L52').asboolean:=true;
    fieldbyname('L61').asboolean:=true;
    post;
  end;
//Program Options4
  with Datawell.TableOptions4 do begin
    append;
    fieldbyname('Master').asinteger:=master;
    post;
  end;
  chars.free;
  acts.free;
  retains.free;
  reverses.free;
  creverses.free;
end;

procedure TFormProfile.BtnCancelClick(Sender: TObject);
begin
  close;
end;

procedure TFormProfile.EditMUDWebsiteChange(Sender: TObject);
begin
  BtnMUDWebsite.enabled:=(EditMUDWebsite.text <> '');
end;

procedure TFormProfile.BtnMUDWebsiteClick(Sender: TObject);
var link: string;
begin
  link:=EditMUDWebsite.text;
  if copy(link,1,5) <> 'http:' then link:='http://'+link;
  Datawell.EXE(link,'','c:\',SW_SHOW);
end;

procedure TFormProfile.EditPlayerKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then begin
    key:=#0;
    case TEdit(sender).tag of
      1: EditPassword.setfocus;
      2: EditMUD.setfocus;
      3: BtnMUD.click;
      4: EditMUDPort.setfocus;
      5: EditMUDWebsite.setfocus;
      6: BtnNew.setfocus;
    end;
  end;
end;

procedure TFormProfile.BtnOKClick(Sender: TObject);
begin
  close;
end;

procedure TFormProfile.AddGauge;
var i: integer;
begin
  i:=Gauge.progress;
  inc(i,4);
  if i > Gauge.maxvalue then i:=Gauge.maxvalue;
  Gauge.progress:=i
end;

procedure TFormProfile.BtnHelpClick(Sender: TObject);
begin
  Datawell.Help('profile');
end;

procedure TFormProfile.BtnSaveClick(Sender: TObject);
var
  mr: TModalResult;
  i: integer;
  isinscript: boolean;
  table: TwwTable;
begin
  isinscript:=false;
  if lowercase(EditPlayer.text) = 'quick' then EditPlayer.text:='Quick';
  if lowercase(EditMud.text) = 'connect' then EditMud.text:='Connect';
  if (EditPlayer.text = 'Quick') and (EditMud.text = 'Connect') then begin
    messagedlg('You can only create the Quick Connect profile from the login screen',
      mtinformation,[mbok],0);
    EditPlayer.text:='';
    EditMud.text:='';
    exit;
  end;
  if EditPlayer.text = '' then begin
    messagedlg('You must enter a player name',mtinformation,[mbok],0);
    EditPlayer.setfocus;
    exit;
  end;
  if MemoScript.lines.count < 1 then begin
    mr:=messagedlg('Generate a default login script for this profile? (recommended)',
      mtinformation,[mbyes,mbno,mbcancel],0);
    if mr = mrcancel then exit;
    if mr = mryes then begin
      MemoScript.lines.add('PLAYER');
      MemoScript.lines.add('PASSWORD');
    end;
  end;
  for i:=0 to MemoScript.lines.count-1 do begin
    if pos('PLAYER',MemoScript.lines[i]) > 0 then begin
      isinscript:=true;
      break;
    end;
  end;
  if (EditPlayer.text <> lowercase(EditPlayer.text)) and (isinscript) then begin
    mr:=messagedlg('Since it is used in the script, the player field should be all lowercase.  Make it so?',
      mtinformation,[mbyes,mbno,mbcancel],0);
    if mr = mrcancel then exit;
    if mr = mryes then begin
      EditPlayer.text:=lowercase(EditPlayer.text);
      EditPlayer.setfocus;
      exit;
    end;
  end;
  if EditMud.text = '' then begin
    messagedlg('You must enter a MUD for the player',mtinformation,[mbok],0);
    BtnMUD.setfocus;
    exit;
  end;
  if EditMUDHost.text = '' then begin
    messagedlg('You need to select a host to connect to',mtinformation,[mbok],0);
    EditMUDHost.setfocus;
    exit;
  end;
  if EditMUDPort.text = '' then begin
    messagedlg('You need to select a connection port',mtinformation,[mbok],0);
    EditMUDPort.setfocus;
    exit;
  end;
//Truncate trailing lines from login script
  while (MemoScript.lines.count > 0) and (MemoScript.lines[MemoScript.lines.count-1] = '') do
    MemoScript.lines.delete(MemoScript.lines.count-1);
  if TBitBtn(sender).tag = 2 then begin //New Player from scratch
    NewPlayer(EditPlayer.text,EditMud.text,EditPassword.text,EditPassword2.text,
      EditMUDHost.text,EditMUDPort.text,EditTrigger.text,EditMUDWebsite.text,
      CheckCR.checked,0,MemoScript.lines);
    wizpassed:=true;
    close;
  end
  else if TBitBtn(sender).tag = 1 then begin //Save changes to existing player
    with Datawell.TableProfiles do begin
      edit;
      fieldbyname('Player').asstring:=EditPlayer.text;
      fieldbyname('Password').asstring:=EditPassword.text;
      fieldbyname('Password2').asstring:=EditPassword2.text;
      fieldbyname('MUD').asstring:=EditMUD.text;
      fieldbyname('Host').asstring:=EditMUDHost.text;
      fieldbyname('Port').asstring:=EditMUDPort.text;
      fieldbyname('URL').asstring:=EditMUDWebsite.Text;
      fieldbyname('Trigger').asstring:=EditTrigger.text;
      fieldbyname('CR').asboolean:=CheckCR.checked;
      fieldbyname('Script').assign(MemoScript.lines);
      post;
      //Clear passwords if it's the last used profile
      if fieldbyname('Master').asinteger = datawell.masterinteger then begin
        Datawell.password:='';
        Datawell.bufferpassword:='';
      end;
    end;
    close;
  end
  else begin //New player from import
    overwriting:=BtnSave.visible;
    StartImport;
  end;
end;

procedure TFormProfile.ClearTable(table: TwwTable);
begin
  table.first;
  while not table.EOF do table.delete;
end;

function TFormProfile.StartImport: boolean;
var
  sfileversion, version, cver: string;
  currentversion: integer;
  failed: boolean;
  lines: TStringList;
begin
  result:=false;
  DialogOpen.initialdir:=Datawell.GetDir(1);
  if not DialogOpen.execute then exit;
  Datawell.SetDir(1,DialogOpen.filename);
  importfile:=lowercase(DialogOpen.filename);
  lines:=TStringList.create;
  try lines.loadfromfile(importfile); except on EFOpenError do failed:=true; end;
  lines.delete(0);
  sfileversion:=lines[0];
  lines.free;
  version:=sfileversion;
  version:=Datawell.subs(DecimalSeparator,'',version);
  version:=Datawell.subs('.','',version);
  version:=Datawell.subs(',','',version);
  try fileversion:=strtoint(version);
    except on EConvertError do begin
      messagedlg('The .TKP file is corrupt',mtinformation,[mbok],0);
      exit;
    end;
  end;
  if fileversion < 6000 then begin
    messagedlg('Sorry, files from before Portal VI are not supported',mtinformation,[mbok],0);
    exit;
  end;
  if (fileversion > 6300) and (fileversion < 7600) then begin
    messagedlg('Beta files can''t be imported',mtinformation,[mbok],0);
    exit;
  end;
  cver:=Datawell.version;
  cver:=Datawell.subs(DecimalSeparator,'',cver);
  cver:=Datawell.subs('.','',cver);
  cver:=Datawell.subs(',','',cver);
  currentversion:=Datawell.toint(cver);
  while copy(sfileversion,length(sfileversion),1) = '0' do
    sfileversion:=copy(sfileversion,1,length(sfileversion)-1);
  if fileversion > currentversion then begin
    messagedlg('You need client version '+sfileversion+' to import that configuration',
      mtinformation,[mbok],0);
    exit;
  end;
  result:=true;
  LabelStatus.caption:='Importing Configuration...';
  PanelMain.enabled:=false;
  Gauge.progress:=0;
  BtnOK.enabled:=false;
  PanelStatus.show;
  PanelStatus.refresh;
  //Clear profile if overwriting
  if overwriting then begin
    with Datawell do begin
      masterglobal:=TableProfiles.fieldbyname('Master').asinteger;
      SetupTables(inttostr(masterglobal));
      ClearTable(TableOptions);
      ClearTable(TableOptions2);
      ClearTable(TableOptions3);
      ClearTable(TableOptions4);
      ClearTable(TableGroups);
      ClearTable(TableRetain);
      ClearTable(TableReverse);
      ClearTable(TableActions);
      ClearTable(TableAliases);
      ClearTable(TableMacros);
      ClearTable(TableMenu);
      ClearTable(TableChat);
      ClearTable(TableChathist);
      ClearTable(TableChatlines);
      ClearTable(TableEvents);
      ClearTable(TableNicknames);
      ClearTable(TableSEvents);
      ClearTable(TableTell);
      ClearTable(TableTellhist);
      ClearTable(TableTells);
      ClearTable(TableTicker);
      ClearTable(TableTools);
      ClearTable(TableVariables);
    end;
  end
  else begin
    //Get new master index
    with Datawell.TableGlobals do begin
      masterglobal:=fieldbyname('I3').asinteger+1;
      edit;
      fieldbyname('I3').asinteger:=masterglobal;
      post;
    end;
  end;
  //Create the new profile
  with Datawell.TableProfiles do begin
    if not overwriting then begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
    end
    else edit;
    fieldbyname('Player').asstring:=EditPlayer.text;
    fieldbyname('Password').asstring:=EditPassword.text;
    fieldbyname('Password2').asstring:=EditPassword2.text;
    fieldbyname('MUD').asstring:=EditMud.text;
    fieldbyname('Host').asstring:=EditMudHost.text;
    fieldbyname('Port').asstring:=EditMudPort.text;
    fieldbyname('URL').asstring:=EditMudWebsite.text;
    fieldbyname('Trigger').asstring:=EditTrigger.text;
    fieldbyname('CR').asboolean:=CheckCR.checked;
    fieldbyname('Script').assign(MemoScript.lines);
    post;
  end;
  wizpassed:=true;
  if wizard then DoImport else TimerImport.enabled:=true;
end;

procedure TFormProfile.TimerImportTimer(Sender: TObject);
begin
  TimerImport.enabled:=false;
  DoImport;
end;

procedure TFormProfile.DoImport;
var
  next, temp: string;
  failed, bwork, didfind: boolean;
  cmds, lines: TStringList;
begin
  lines:=TStringList.create;
  try lines.loadfromfile(importfile); except on EFOpenError do failed:=true; end;
  lines.delete(0);
  lines.delete(0);
//TIME: Date|Seconds - defunct
  next:='ACTIONS';
  while copy(lines[0],9,length(next)) <> next do begin
    lines.delete(0);
    lines.delete(0);
  end;
  AddGauge;
//ACTIONS: Character|Action
  next:='ALIASES';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableActions do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Character').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Action').asstring:=lines[0];
      try post; except on EDBEngineError do cancel; end;
    end;
    lines.delete(0);
  end;
  AddGauge;
//ALIASES: Alias|Script
  next:='ACOMMANDS';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableAliases do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Alias').asstring:=lines[0];
      // 7.000 added: Script
      if fileversion >= 7000 then begin
        cmds:=TStringList.create;
        lines.delete(0);
        while copy(lines[0],1,11) <> '<ENDSCRIPT>' do begin
          cmds.add(lines[0]);
          lines.delete(0);
        end;
        fieldbyname('Script').assign(cmds);
        cmds.free;
      end;
      try post; except on EDBEngineError do cancel; end;
    end;
    lines.delete(0);
  end;
  AddGauge;
// ACOMMANDS: Group|Alias|Command //defunct
  next:='CHATLINES';
  lines.delete(0);
  if fileversion >= 7000 then begin
    while copy(lines[0],9,length(next)) <> next do lines.delete(0);
  end
  else begin
    with Datawell.TableAliases do begin
      refresh;
      wwfilter.clear;
      wwfilter.add('Master = '+inttostr(masterglobal));
      filterActivate;
      active:=true;
    end;
    while copy(lines[0],9,length(next)) <> next do begin
      lines.delete(0); //To skip the vestigal line regarding grouping
      with Datawell.TableAliases do begin
        didfind:=false;
        first;
        while not EOF do begin
          if fieldbyname('Alias').asstring = lines[0] then begin
            didfind:=true;
            cmds:=TStringList.create;
            cmds.assign(fieldbyname('Script'));
            lines.delete(0);
            cmds.add(lines[0]);
            edit;
            fieldbyname('Script').assign(cmds);
            try post; except on EDBEngineError do cancel; end;
            break;
          end;
          next;
        end;
        if not didfind then lines.delete(0); //Can't find it, so trash the command
      end;
      lines.delete(0);
    end;
  end;
  AddGauge;
//CHATLINES: Line|Command|Mask|FGColor|BGColor
  next:='EVENTS';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    if IsClean(lines[0]) then begin
      with Datawell.TableChatlines do begin
        append;
        fieldbyname('Master').asinteger:=masterglobal;
        fieldbyname('Line').asstring:=lines[0];
        lines.delete(0);
        fieldbyname('Command').asstring:=lines[0];
        lines.delete(0);
        fieldbyname('Mask').asstring:=lines[0];
        lines.delete(0);
        fieldbyname('FGColor').asinteger:=strtoint(lines[0]);
        lines.delete(0);
        fieldbyname('BGColor').asinteger:=strtoint(lines[0]);
        try post; except on EDBEngineError do cancel; end;
      end;
    end
    else begin
      lines.delete(0);
      lines.delete(0);
      lines.delete(0);
      lines.delete(0);
    end;
    lines.delete(0);
  end;
  AddGauge;
//EVENTS: Group|Event|Action|Sound|Soundfile|Fcolor|BColor|Filtered|Retain|Script
  next:='ECOMMANDS';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableEvents do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Group').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Event').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Action').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Sound').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Soundfile').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('FColor').asinteger:=strtoint(lines[0]);
      lines.delete(0);
      fieldbyname('BColor').asinteger:=strtoint(lines[0]);
      lines.delete(0);
      if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
      fieldbyname('CaseSensitive').asboolean:=bwork;
      lines.delete(0);
      if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
      fieldbyname('Terminal').asboolean:=bwork;
      lines.delete(0);
      fieldbyname('Order').asinteger:=strtoint(lines[0]);
      // 7.000 added: Filtered, Retain, Script
      if fileversion >= 7000 then begin
        lines.delete(0);
        if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
        fieldbyname('Filtered').asboolean:=bwork;
        lines.delete(0);
        if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
        fieldbyname('Retain').asboolean:=bwork;
        cmds:=TStringList.create;
        lines.delete(0);
        while copy(lines[0],1,11) <> '<ENDSCRIPT>' do begin
          cmds.add(lines[0]);
          lines.delete(0);
        end;
        fieldbyname('Script').assign(cmds);
        cmds.free;
      end
      else begin
        fieldbyname('Filtered').asboolean:=false;
        fieldbyname('Retain').asboolean:=true;
      end;
      try post; except on EDBEngineError do cancel; end;
    end;
    lines.delete(0);
  end;
  AddGauge;
//ECOMMANDS: Group|Event|Command //defunct
  next:='FILTERS';
  lines.delete(0);
  if fileversion >= 7000 then begin
    while copy(lines[0],9,length(next)) <> next do lines.delete(0);
  end
  else begin
    while copy(lines[0],9,length(next)) <> next do begin
      with Datawell.TableEvents do begin  //Refresh group filter for the next command
        refresh;
        wwfilter.clear;
        wwfilter.add('(Master = '+inttostr(masterglobal)+')');
        wwfilter.add('(Group = "'+lines[0]+'")');
        filterActivate;
        active:=true;
      end;
      lines.delete(0); //Skip the group to get the event
      with Datawell.TableEvents do begin
        didfind:=false;
        first;
        while not EOF do begin
          if fieldbyname('Event').asstring = lines[0] then begin
            didfind:=true;
            cmds:=TStringList.create;
            cmds.assign(fieldbyname('Script'));
            lines.delete(0);
            cmds.add(lines[0]);
            edit;
            fieldbyname('Script').assign(cmds);
            try post; except on EDBEngineError do cancel; end;
            break;
          end;
          next;
        end;
        if not didfind then lines.delete(0);
      end;
      lines.delete(0);
    end;
  end;
  AddGauge;
//FILTERS: Group|Filter //defunct
  next:='GROUPS';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do lines.delete(0);
  AddGauge;
//GROUPS: Group
  next:='MCOMMANDS';
  if fileversion >= 7000 then next:='MACROS';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableGroups do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Group').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('FGColor').asinteger:=strtoint(lines[0]);
      lines.delete(0);
      fieldbyname('BGColor').asinteger:=strtoint(lines[0]);
      try post; except on EDBEngineError do cancel; end;
    end;
    lines.delete(0);
  end;
  AddGauge;
//MACROS: Macro|Script
  if fileversion >= 7000 then begin
    next:='MCOMMANDS';
    lines.delete(0);
    while copy(lines[0],9,length(next)) <> next do begin
      with Datawell.TableMacros do begin
        append;
        fieldbyname('Master').asinteger:=masterglobal;
        fieldbyname('Macro').asstring:=lines[0];
        lines.delete(0);
        fieldbyname('Order').asstring:=lines[0];
        cmds:=TStringList.create;
        lines.delete(0);
        while copy(lines[0],1,11) <> '<ENDSCRIPT>' do begin
          cmds.add(lines[0]);
          lines.delete(0);
        end;
        fieldbyname('Script').assign(cmds);
        cmds.free;
        try post; except on EDBEngineError do cancel; end;
      end;
      lines.delete(0);
    end;
    AddGauge;
  end
  else ResetMacros(masterglobal,false);
//MCOMMANDS: Group|Macro|Command //defunct
  next:='NICKNAMES';
  if fileversion >= 7000 then next:='MENUS';
  lines.delete(0);
  if fileversion >= 7000 then begin
    while copy(lines[0],9,length(next)) <> next do lines.delete(0);
  end
  else begin
    with Datawell.TableMacros do begin
      refresh;
      wwfilter.clear;
      wwfilter.add('Master = '+inttostr(masterglobal));
      filterActivate;
      active:=true;
    end;
    while copy(lines[0],9,length(next)) <> next do begin
      lines.delete(0); //To skip the vestigal line regarding grouping
      with Datawell.TableMacros do begin
        didfind:=false;
        first;
        while not EOF do begin
          if fieldbyname('Macro').asstring = lines[0] then begin
            didfind:=true;
            cmds:=TStringList.create;
            cmds.assign(fieldbyname('Script'));
            lines.delete(0);
            cmds.add(lines[0]);
            edit;
            fieldbyname('Script').assign(cmds);
            try post; except on EDBEngineError do cancel; end;
            break;
          end;
          next;
        end;
        if not didfind then lines.delete(0); //Can't find it, so trash the command
      end;
      lines.delete(0);
    end;
  end;
  AddGauge;
//MENUS: Index|Item|Hotkey
  if fileversion >= 7000 then begin
    next:='NICKNAMES';
    lines.delete(0);
    while copy(lines[0],9,length(next)) <> next do begin
      with Datawell.TableMenu do begin
        append;
        fieldbyname('Master').asinteger:=masterglobal;
        fieldbyname('Index').asinteger:=strtoint(lines[0]);
        lines.delete(0);
        fieldbyname('Item').asstring:=lines[0];
        lines.delete(0);
        fieldbyname('Hotkey').asstring:=lines[0];
        try post; except on EDBEngineError do cancel; end;
      end;
      lines.delete(0);
    end;
  end;
  AddGauge;
//NICKNAMES: Group|Nickname|Replacement
  next:='RETAIN';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableNicknames do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      if fileversion < 7000 then lines.delete(0); //Hack off vestigal group info
      fieldbyname('Nickname').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Replacement').asstring:=lines[0];
      try post; except on EDBEngineError do cancel; end;
    end;
    lines.delete(0);
  end;
  AddGauge;
//RETAIN: Retain|AddSpace|KeepSelected
  next:='REVERSE';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableRetain do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Retain').asstring:=lines[0];
      lines.delete(0);
      if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
      fieldbyname('AddSpace').asboolean:=bwork;
      lines.delete(0);
      if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
      fieldbyname('KeepSelected').asboolean:=bwork;
      try post; except on EDBEngineError do cancel; end;
    end;
    lines.delete(0);
  end;
  AddGauge;
//REVERSE: Command|Reverse
  next:='SCHEDULE';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableReverse do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Command').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Reverse').asstring:=lines[0];
      try post; except on EDBEngineError do cancel; end;
    end;
   lines.delete(0);
  end;
  AddGauge;
//SCHEDULE: Date|Time|Alert|Sound|Action|Alias //defunct
  next:='SEVENTS';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do lines.delete(0);
  AddGauge;
//SEVENTS: Group|Kind|Action|Sound
  next:='TOOLS';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableSEvents do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Group').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Kind').asinteger:=strtoint(lines[0]);
      lines.delete(0);
      fieldbyname('Action').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Sound').asstring:=lines[0];
      try post; except on EDBEngineError do cancel; end;
    end;
    lines.delete(0);
  end;
  AddGauge;
//TOOLS: Tool|Filename
  next:='TELLS';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableTools do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Tool').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Filename').asstring:=lines[0];
    end;
    lines.delete(0);
  end;
  AddGauge;
//TELLS: From|FGColor|BGColor
  next:='TICKER';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    if IsClean(lines[0]) then begin
      with Datawell.TableTells do begin
        append;
        fieldbyname('Master').asinteger:=masterglobal;
        fieldbyname('From').asstring:=lines[0];
        lines.delete(0);
        fieldbyname('FGColor').asinteger:=strtoint(lines[0]);
        lines.delete(0);
        fieldbyname('BGColor').asinteger:=strtoint(lines[0]);
        try post; except on EDBEngineError do cancel; end;
      end;
    end
    else begin
      lines.delete(0);
      lines.delete(0);
    end;
    lines.delete(0);
  end;
  AddGauge;
//TICKER: Tick|Action|Alias
  next:='VARIABLES';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableTicker do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Tick').asinteger:=strtoint(lines[0]);
      lines.delete(0);
      fieldbyname('Action').asstring:=lines[0];
      if fileversion < 7000 then lines.delete(0); //Hack off vestigal Alias field
      try post; except on EDBEngineError do cancel; end;
    end;
    lines.delete(0);
  end;
  AddGauge;
//VARIABLES: Variable|Value|FColor|BColor|Initialize
  next:='OPTIONS';
  lines.delete(0);
  while copy(lines[0],9,length(next)) <> next do begin
    with Datawell.TableVariables do begin
      append;
      fieldbyname('Master').asinteger:=masterglobal;
      fieldbyname('Variable').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('Value').asstring:=lines[0];
      lines.delete(0);
      fieldbyname('FColor').asinteger:=strtoint(lines[0]);
      lines.delete(0);
      fieldbyname('BColor').asinteger:=strtoint(lines[0]);
      lines.delete(0);
      fieldbyname('Initialize').asstring:=lines[0];
      try post; except on EDBEngineError do cancel; end;
    end;
    lines.delete(0);
  end;
  AddGauge;
//OPTIONS
  with Datawell.TableOptions do begin
    append;
    fieldbyname('Master').asinteger:=masterglobal;
    lines.delete(0);
    fieldbyname('Group').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('DirFiles').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('DirSounds').asstring:=lines[0];
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Menu').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Escape').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Tab').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ShowHP').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ShowHP2').asboolean:=bwork;
    lines.delete(0);
    //Clean vestigal buttons from the toolbar
    temp:=lines[0];
    while pos('i',temp) > 0 do system.delete(temp,pos('i',temp),1);
    while pos('u',temp) > 0 do system.delete(temp,pos('u',temp),1);
    while pos('V',temp) > 0 do system.delete(temp,pos('V',temp),1);
    while pos('6',temp) > 0 do system.delete(temp,pos('6',temp),1);
    while pos('7',temp) > 0 do system.delete(temp,pos('7',temp),1);
    while pos('0',temp) > 0 do system.delete(temp,pos('0',temp),1);
    while pos(';',temp) > 0 do system.delete(temp,pos(';',temp),1);
    while pos('+',temp) > 0 do system.delete(temp,pos('+',temp),1);
    while pos('<',temp) > 0 do system.delete(temp,pos('<',temp),1);
    fieldbyname('Toolbar').asstring:=temp;
    lines.delete(0);
    fieldbyname('FToolbar').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('ScrollPosition').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Pageup').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FeedScrollback').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ScrollbackLabels').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('AutotypeSave').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EventsOnFilter').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Autocopy').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ClearSending').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('Scroll').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('History').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Chars').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Special').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('SpecialDuration').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color21').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color22').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color23').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Beep').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('LoginMacro').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('LinkdeadMacro').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Activator').asstring:=lines[0];
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Animate').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Sounds').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EventSounds').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Typed').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('FColorTyped').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorTyped').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Autotyper').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('FColorAutotyper').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorAutotyper').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Aliases').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('FColorAliases').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorAliases').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Macros').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('FColorMacros').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorMacros').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Events').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('FColorEvents').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorEvents').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Pasted').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('FColorPasted').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorPasted').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('HP').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('SP').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('GP1').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('GP2').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Enemy').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('HP2').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('SP2').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('GP12').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('GP22').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Enemy2').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Top').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Left').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Height').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Width').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FontName').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('FontStyle').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FontSize').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ToolbarShowing').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('HelpbarShowing').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('StatusTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('StatusLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('StatusShowing').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('StatusStayOnTop').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('TellTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('TellLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('TellHeight').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('TellWidth').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('TellStayOnTop').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('TellShowing').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('TellExpanded').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('EditorTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('EditorLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('EditorHeight').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('EditorWidth').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('EditorFontName').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('EditorFontStyle').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('EditorFontSize').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EditorWrap').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EditorShowWidthbar').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EditorAsk').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EditorClear').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('ImageryTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ImageryLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ImageryShowing').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('cl1').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('cl2').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('cl3').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('cl4').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('cl5').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('cm1').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('cm2').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('cm3').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('cm4').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('cm5').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ch1').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ch2').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ch3').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ch4').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ch5').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('c1001').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('c1002').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('c1003').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('c1004').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('c1005').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('co1').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('co2').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('co3').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('co4').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('co5').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Last0').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Last1').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Last2').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Last3').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Last4').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Last5').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Last6').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Last7').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Last8').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('Last9').asstring:=lines[0];
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NTyped').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NAutotyper').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NAliases').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NMacros').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NEvents').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NPasted').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('FToolbarTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FToolbarLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FToolbarHeight').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FToolbarWidth').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FToolbarVertical').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FToolbarShowing').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FToolbarStayOnTop').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('MessagesTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('MessagesLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('MessagesWidth').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('MessagesStayOnTop').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('MessagesShowing').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('ChatTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ChatLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ChatHeight').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ChatWidth').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ChatStayOnTop').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ChatExpanded').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ChatShowing').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('ChatLineHeight').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ChatShowLineGrid').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('ChatLineGridHeight').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ColorScreen').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ColorText').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color0').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color1').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color2').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color3').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color4').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color5').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color6').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color7').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color8').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color9').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color10').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color11').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color12').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color13').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color14').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Color15').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Anchors').asstring:=lines[0];
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('AltF4ToClose').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ReverseKeymap').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Retain').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('RetainAll').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EnableTicker').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('PanicMacro').asstring:=lines[0];
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('AddBang').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('FColorSelected').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorSelected').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ParsingChar').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('Quickchar').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('FColorSystem').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorSystem').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ShowHP3').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('ImageryHeight').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ImageryWidth').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('ImageryColor').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ImageryStayOnTop').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EditorStayOnTop').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ImageryShowGauge').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ImageryShowLabel').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ShowHP4').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('HP3Offset').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('HP4Offset').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('GP1Mask').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('GP2Mask').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('HP3Size').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('HP4Size').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('HighlightKeyhistory').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DTyped').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DAutotyper').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DAliases').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DPasted').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DMacros').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DEvents').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EQuickchars').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EScheduler').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('ETicker').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EParsed').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NQuickchars').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NScheduler').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NTicker').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('NParsed').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DQuickchars').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DScheduler').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DTicker').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DParsed').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('FColorQuickchars').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorQuickchars').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FColorScheduler').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorScheduler').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FColorTicker').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorTicker').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FColorParsed').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('BColorParsed').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FilteredTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FilteredLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FilteredHeight').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('FilteredWidth').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FilteredShowing').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FilteredStayOnTop').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('EditorFColor').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('EditorBColor').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('UseLocalDir').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('LocalDir').asstring:=lines[0];
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('OverwriteLocalDir').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('MenuHotkeys').asstring:=lines[0];
    post;
  end;
  AddGauge;
// Options2
  with Datawell.TableOptions2 do begin
    append;
    fieldbyname('Master').asinteger:=masterglobal;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BTyped').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BAutotyped').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BPasted').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BAliases').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BMacros').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BEvents').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BQuickchars').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BScheduler').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BTicker').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('BParsed').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('Truncate').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('VarTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('VarLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('VarHeight').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VarShowing').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VarStayOnTop').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VTyped').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VAutotyped').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VPasted').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VAliases').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VMacros').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VEvents').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VQuickchars').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VScheduler').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VTicker').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('VParsed').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('Groups').asstring:=lines[0];
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('AutoShowImagery').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('EnableHyperlinks').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('HyperlinkFGColor').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('HyperlinkBGColor').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('Browser').asstring:=lines[0];
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FTyped').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FAutotyped').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FPasted').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FAliases').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FMacros').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FEvents').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FQuickchars').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FScheduler').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FTicker').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FParsed').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PTyped').asboolean:=bwork;
    //Always require this to be parsed
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PAutotyped').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PPasted').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PAliases').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PMacros').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PEvents').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PQuickchars').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PScheduler').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PTicker').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PParsed').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('MapShowing').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('MapTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('MapLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('MapStayOnTop').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DisableAliasLED').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('AutoExpand').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('WebsitesShowing').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('WebsitesStayOnTop').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('WebsitesTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('WebsitesLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DataShowing').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DataStayOnTop').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('DataTop').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('DataLeft').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    fieldbyname('PastedDelay').asinteger:=strtoint(lines[0]);
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('FullFlash').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('HPMask').asstring:=lines[0];
    lines.delete(0);
    fieldbyname('SPMask').asstring:=lines[0];
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('DelayUpload').asboolean:=bwork;
    lines.delete(0);
    if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('PCorrect').asboolean:=bwork;
    lines.delete(0);
    fieldbyname('PanicMacro2').asstring:=lines[0];
    post;
  end;
  AddGauge;
// Options3
  with Datawell.TableOptions3 do begin
    append;
    fieldbyname('Master').asinteger:=masterglobal;
    lines.delete(0); fieldbyname('S1').asstring:=lines[0];
    lines.delete(0); fieldbyname('S2').asstring:=lines[0];
    lines.delete(0); fieldbyname('S3').asstring:=lines[0];
    lines.delete(0); fieldbyname('S4').asstring:=lines[0];
    lines.delete(0); fieldbyname('S5').asstring:=lines[0];
    lines.delete(0); fieldbyname('S6').asstring:=lines[0];
    lines.delete(0); fieldbyname('S7').asstring:=lines[0];
    lines.delete(0); fieldbyname('S8').asstring:=lines[0];
    lines.delete(0); fieldbyname('S9').asstring:=lines[0];
    lines.delete(0); fieldbyname('S10').asstring:=lines[0];
    lines.delete(0); fieldbyname('S11').asstring:=lines[0];
    lines.delete(0); fieldbyname('S12').asstring:=lines[0];
    lines.delete(0); fieldbyname('S13').asstring:=lines[0];
    lines.delete(0); fieldbyname('S14').asstring:=lines[0];
    lines.delete(0); fieldbyname('S15').asstring:=lines[0];
    lines.delete(0); fieldbyname('S16').asstring:=lines[0];
    lines.delete(0); fieldbyname('S17').asstring:=lines[0];
    lines.delete(0); fieldbyname('S18').asstring:=lines[0];
    lines.delete(0); fieldbyname('S19').asstring:=lines[0];
    lines.delete(0); fieldbyname('S20').asstring:=lines[0];
    lines.delete(0); fieldbyname('S21').asstring:=lines[0];
    lines.delete(0); fieldbyname('S22').asstring:=lines[0];
    lines.delete(0); fieldbyname('S23').asstring:=lines[0];
    lines.delete(0); fieldbyname('S24').asstring:=lines[0];
    lines.delete(0); fieldbyname('S25').asstring:=lines[0];
    lines.delete(0); fieldbyname('S26').asstring:=lines[0];
    lines.delete(0); fieldbyname('S27').asstring:=lines[0];
    lines.delete(0); fieldbyname('S28').asstring:=lines[0];
    lines.delete(0); fieldbyname('S29').asstring:=lines[0];
    lines.delete(0); fieldbyname('S30').asstring:=lines[0];
    lines.delete(0); fieldbyname('S31').asstring:=lines[0];
    lines.delete(0); fieldbyname('S32').asstring:=lines[0];
    lines.delete(0); fieldbyname('S33').asstring:=lines[0];
    lines.delete(0); fieldbyname('S34').asstring:=lines[0];
    lines.delete(0); fieldbyname('S35').asstring:=lines[0];
    lines.delete(0); fieldbyname('S36').asstring:=lines[0];
    lines.delete(0); fieldbyname('S37').asstring:=lines[0];
    lines.delete(0); fieldbyname('S38').asstring:=lines[0];
    lines.delete(0); fieldbyname('S39').asstring:=lines[0];
    lines.delete(0); fieldbyname('S40').asstring:=lines[0];
    lines.delete(0); fieldbyname('S41').asstring:=lines[0];
    lines.delete(0); fieldbyname('S42').asstring:=lines[0];
    lines.delete(0); fieldbyname('S43').asstring:=lines[0];
    lines.delete(0); fieldbyname('S44').asstring:=lines[0];
    lines.delete(0); fieldbyname('S45').asstring:=lines[0];
    lines.delete(0); fieldbyname('S46').asstring:=lines[0];
    lines.delete(0); fieldbyname('S47').asstring:=lines[0];
    lines.delete(0); fieldbyname('S48').asstring:=lines[0];
    lines.delete(0); fieldbyname('S49').asstring:=lines[0];
    lines.delete(0); fieldbyname('S50').asstring:=lines[0];
    lines.delete(0); fieldbyname('S51').asstring:=lines[0];
    lines.delete(0); fieldbyname('S52').asstring:=lines[0];
    lines.delete(0); fieldbyname('S53').asstring:=lines[0];
    lines.delete(0); fieldbyname('S54').asstring:=lines[0];
    lines.delete(0); fieldbyname('S55').asstring:=lines[0];
    lines.delete(0); fieldbyname('S56').asstring:=lines[0];
    lines.delete(0); fieldbyname('S57').asstring:=lines[0];
    lines.delete(0); fieldbyname('S58').asstring:=lines[0];
    lines.delete(0); fieldbyname('S59').asstring:=lines[0];
    lines.delete(0); fieldbyname('S60').asstring:=lines[0];
    lines.delete(0); fieldbyname('S61').asstring:=lines[0];
    lines.delete(0); fieldbyname('S62').asstring:=lines[0];
    lines.delete(0); fieldbyname('S63').asstring:=lines[0];
    lines.delete(0); fieldbyname('S64').asstring:=lines[0];
    lines.delete(0); fieldbyname('S65').asstring:=lines[0];
    lines.delete(0); fieldbyname('S66').asstring:=lines[0];
    lines.delete(0); fieldbyname('S67').asstring:=lines[0];
    lines.delete(0); fieldbyname('S68').asstring:=lines[0];
    lines.delete(0); fieldbyname('S69').asstring:=lines[0];
    lines.delete(0); fieldbyname('S70').asstring:=lines[0];
    lines.delete(0); fieldbyname('S71').asstring:=lines[0];
    lines.delete(0); fieldbyname('S72').asstring:=lines[0];
    lines.delete(0); fieldbyname('S73').asstring:=lines[0];
    lines.delete(0); fieldbyname('S74').asstring:=lines[0];
    lines.delete(0); fieldbyname('S75').asstring:=lines[0];
    lines.delete(0); fieldbyname('I1').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I2').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I3').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I4').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I5').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I6').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I7').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I8').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I9').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I10').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I11').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I12').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I13').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I14').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I15').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I16').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I17').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I18').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I19').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I20').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I21').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I22').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I23').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I24').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I25').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I26').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I27').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I28').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I29').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I30').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I31').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I32').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I33').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I34').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I35').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I36').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I37').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I38').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I39').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I40').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I41').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I42').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I43').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I44').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I45').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I46').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I47').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I48').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I49').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I50').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I51').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I52').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I53').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I54').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I55').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I56').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I57').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I58').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I59').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I60').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I61').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I62').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I63').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I64').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I65').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I66').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I67').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I68').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I69').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I70').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I71').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I72').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I73').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I74').asinteger:=strtoint(lines[0]);
    lines.delete(0); fieldbyname('I75').asinteger:=strtoint(lines[0]);
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L1').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L2').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L3').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L4').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L5').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L6').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L7').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L8').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L9').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L10').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L11').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L12').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L13').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L14').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L15').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L16').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L17').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L18').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L19').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L20').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L21').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L22').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L23').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L24').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L25').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L26').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L27').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L28').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L29').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L30').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L31').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L32').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L33').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L34').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L35').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L36').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L37').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L38').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L39').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L40').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L41').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L42').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L43').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L44').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L45').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L46').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L47').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L48').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L49').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L50').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L51').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L52').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L53').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L54').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L55').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L56').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L57').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L58').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L59').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L60').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L61').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L62').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L63').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L64').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L65').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L66').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L67').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L68').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L69').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L70').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L71').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L72').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L73').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L74').asboolean:=bwork;
    lines.delete(0); if lines[0] = 'TRUE' then bwork:=true else bwork:=false;
    fieldbyname('L75').asboolean:=bwork;
    lines.delete(0); fieldbyname('Tool1').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool2').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool3').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool4').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool5').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool6').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool7').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool8').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool9').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool10').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool11').asstring:=lines[0];
    lines.delete(0); fieldbyname('Tool12').asstring:=lines[0];
    if fileversion <= 6200 then begin //Clean up some crap for GT
      fieldbyname('I1').asinteger:=0;
      fieldbyname('I2').asinteger:=0;
      fieldbyname('I3').asinteger:=480;
      fieldbyname('I4').asinteger:=640;
      fieldbyname('I5').asinteger:=14;
      fieldbyname('I6').asinteger:=0;
      fieldbyname('I12').asinteger:=0;
      fieldbyname('I13').asinteger:=0;
      fieldbyname('I14').asinteger:=300;
      fieldbyname('I15').asinteger:=350;
      fieldbyname('I16').asinteger:=clteal;
      fieldbyname('I17').asinteger:=300;
      fieldbyname('I18').asinteger:=300;
      fieldbyname('I19').asinteger:=clsilver;
      fieldbyname('I20').asinteger:=clblack;
      fieldbyname('I21').asinteger:=clwhite;
      fieldbyname('I22').asinteger:=clblack;
      fieldbyname('I25').asinteger:=10;
      fieldbyname('I26').asinteger:=clgray;
      fieldbyname('I27').asinteger:=clyellow;
      fieldbyname('I28').asinteger:=300;
      fieldbyname('I29').asinteger:=80;
      fieldbyname('L1').asboolean:=false;
      fieldbyname('L2').asboolean:=true;
      fieldbyname('L3').asboolean:=false;
      fieldbyname('L4').asboolean:=false;
      fieldbyname('L5').asboolean:=true;
      fieldbyname('L6').asboolean:=true;
      fieldbyname('L7').asboolean:=true;
      fieldbyname('L8').asboolean:=true;
      fieldbyname('L9').asboolean:=true;
      fieldbyname('L11').asboolean:=false;
      fieldbyname('L12').asboolean:=false;
      fieldbyname('L13').asboolean:=true;
      fieldbyname('L14').asboolean:=false;
      fieldbyname('L15').asboolean:=false;
      fieldbyname('L16').asboolean:=true;
      fieldbyname('L17').asboolean:=false;
      fieldbyname('L19').asboolean:=false;
      fieldbyname('L20').asboolean:=false;
      fieldbyname('L21').asboolean:=true;
      fieldbyname('L22').asboolean:=false;
      fieldbyname('L23').asboolean:=false;
      fieldbyname('L24').asboolean:=true;
      fieldbyname('L25').asboolean:=true;
      fieldbyname('L26').asboolean:=true;
      fieldbyname('L27').asboolean:=true;
      fieldbyname('L28').asboolean:=true;
      fieldbyname('L29').asboolean:=true;
      fieldbyname('L30').asboolean:=true;
      fieldbyname('L31').asboolean:=false;
      fieldbyname('L32').asboolean:=false;
      fieldbyname('L33').asboolean:=true;
      fieldbyname('L34').asboolean:=false;
      fieldbyname('L35').asboolean:=true;
      fieldbyname('L36').asboolean:=true;
      fieldbyname('L37').asboolean:=true;
      fieldbyname('L38').asboolean:=true;
      fieldbyname('L39').asboolean:=true;
      fieldbyname('L40').asboolean:=true;
      fieldbyname('L42').asboolean:=false;
      fieldbyname('L43').asboolean:=false;
      fieldbyname('L44').asboolean:=true;
    end
    else if fileversion <= 7000 then begin //Clean up some more crap for GT
      fieldbyname('S1').asstring:='';
      fieldbyname('S2').asstring:='[36';
      fieldbyname('I26').asinteger:=clgray;
      fieldbyname('I27').asinteger:=clyellow;
      fieldbyname('I28').asinteger:=300;
      fieldbyname('L45').asboolean:=true;
      fieldbyname('L46').asboolean:=false;
      fieldbyname('L47').asboolean:=false;
      fieldbyname('L48').asboolean:=false;
      fieldbyname('L49').asboolean:=true;
      fieldbyname('L50').asboolean:=true;
      fieldbyname('L51').asboolean:=false;
      fieldbyname('L52').asboolean:=true;
    end;
    post;
  end;
  AddGauge;
// Options4
  with Datawell.TableOptions4 do begin
    append;
    fieldbyname('Master').asinteger:=masterglobal;
    lines.delete(0); fieldbyname('S1').asstring:=lines[0];
    lines.delete(0); fieldbyname('S2').asstring:=lines[0];
    lines.delete(0); fieldbyname('S3').asstring:=lines[0];
    lines.delete(0); fieldbyname('S4').asstring:=lines[0];
    lines.delete(0); fieldbyname('S5').asstring:=lines[0];
    lines.delete(0); fieldbyname('S6').asstring:=lines[0];
    lines.delete(0); fieldbyname('S7').asstring:=lines[0];
    lines.delete(0); fieldbyname('S8').asstring:=lines[0];
    lines.delete(0); fieldbyname('S9').asstring:=lines[0];
    lines.delete(0); fieldbyname('S10').asstring:=lines[0];
    lines.delete(0); fieldbyname('S11').asstring:=lines[0];
    lines.delete(0); fieldbyname('S12').asstring:=lines[0];
    lines.delete(0); fieldbyname('S13').asstring:=lines[0];
    lines.delete(0); fieldbyname('S14').asstring:=lines[0];
    lines.delete(0); fieldbyname('S15').asstring:=lines[0];
    lines.delete(0); fieldbyname('S16').asstring:=lines[0];
    lines.delete(0); fieldbyname('S17').asstring:=lines[0];
    lines.delete(0); fieldbyname('S18').asstring:=lines[0];
    lines.delete(0); fieldbyname('S19').asstring:=lines[0];
    lines.delete(0); fieldbyname('S20').asstring:=lines[0];
    lines.delete(0); fieldbyname('S21').asstring:=lines[0];
    lines.delete(0); fieldbyname('S22').asstring:=lines[0];
    lines.delete(0); fieldbyname('S23').asstring:=lines[0];
    lines.delete(0); fieldbyname('S24').asstring:=lines[0];
    lines.delete(0); fieldbyname('S25').asstring:=lines[0];
    lines.delete(0); fieldbyname('S26').asstring:=lines[0];
    lines.delete(0); fieldbyname('S27').asstring:=lines[0];
    lines.delete(0); fieldbyname('S28').asstring:=lines[0];
    lines.delete(0); fieldbyname('S29').asstring:=lines[0];
    lines.delete(0); fieldbyname('S30').asstring:=lines[0];
    lines.delete(0); fieldbyname('S31').asstring:=lines[0];
    lines.delete(0); fieldbyname('S32').asstring:=lines[0];
    lines.delete(0); fieldbyname('S33').asstring:=lines[0];
    lines.delete(0); fieldbyname('S34').asstring:=lines[0];
    lines.delete(0); fieldbyname('S35').asstring:=lines[0];
    lines.delete(0); fieldbyname('S36').asstring:=lines[0];
    lines.delete(0); fieldbyname('S37').asstring:=lines[0];
    lines.delete(0); fieldbyname('S38').asstring:=lines[0];
    lines.delete(0); fieldbyname('S39').asstring:=lines[0];
    lines.delete(0); fieldbyname('S40').asstring:=lines[0];
    post;
  end;
// Done adding
  Gauge.progress:=100;
  lines.free;
  LabelStatus.caption:='Import successful!';
  BtnOk.enabled:=true;
end;

function TFormProfile.IsClean(str: string): boolean;
var i: integer;
begin
  result:=true;
  for i:=1 to length(str) do begin
    if (ord(str[i]) < 32) or (ord(str[i]) > 126) then begin
      result:=false;
      break;
    end;
  end;
end;

end.
